SystemOrganization addCategory: #Benchmark!
SystemOrganization addCategory: #'Benchmark-Tests'!
SystemOrganization addCategory: #'Benchmark-GUI'!

Morph subclass: #BenchmarkWarmupGraph
	instanceVariableNames: 'benchName results min max timers incGCresults fullGCresults previousFocus resultExtent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark-GUI'!

!BenchmarkWarmupGraph class methodsFor: 'instance creation' stamp: 'tfel 4/19/2016 16:22'!
forBenchmark: benchName results: aCollection

	^ self basicNew
		initialize;
		color: Color white;
		width: 500;
		height: 200;
		benchName: benchName;
		results: aCollection;
		yourself! !

!BenchmarkWarmupGraph class methodsFor: 'instance creation' stamp: 'tfel 4/19/2016 16:22'!
new

	self shouldNotImplement! !

!BenchmarkWarmupGraph methodsFor: 'menus' stamp: 'tfel 4/20/2016 14:53'!
addExportMenuItems: aMenu hand: aHandMorph

	super addExportMenuItems: aMenu hand: aHandMorph.
	aMenu ifNotNil:
		[aMenu add: 'export to EPS' translated action: #printEPSToFile].! !

!BenchmarkWarmupGraph methodsFor: 'accessing' stamp: 'tfel 4/21/2016 17:51'!
balloonText
	
	^ '' "Overridden in actual popup code"! !

!BenchmarkWarmupGraph methodsFor: 'accessing' stamp: 'tfel 4/21/2016 13:51'!
benchName: anObject

	benchName := anObject.
	! !

!BenchmarkWarmupGraph methodsFor: 'drawing' stamp: 'tfel 4/21/2016 17:29'!
drawLineson: aCanvas
	| i bW |
	i := 0.
	bW := (self width / results size) ceiling.
	((incGCresults with: fullGCresults collect: [:incR :fullR | {incR. fullR}]))
		with: results do: [:gcary :r || incR fullR |
			incR := gcary first.
			fullR := gcary second.
			i := i + 1.
			fullR > 0 ifTrue: [
				aCanvas
					line: (self normalizePoint: i@r)
					to: (self normalizePoint: i@(r - fullR))
					width: bW
					color: Color red darker].
			incR > 0 ifTrue: [
				aCanvas
					line: (self normalizePoint: i@(r - fullR))
					to: (self normalizePoint: i@(r - fullR - incR))
					width: bW
					color: Color orange].
			aCanvas
				line: (self normalizePoint: i@(r - fullR - incR))
				to: (self normalizePoint: i@min)
				width: bW
				color: Color gray lighter].
! !

!BenchmarkWarmupGraph methodsFor: 'drawing' stamp: 'tfel 4/21/2016 17:16'!
drawOn: originalCanvas
	
	originalCanvas translateBy: self topLeft clippingTo: self bounds during: [:aCanvas |
		| points |
		points := OrderedCollection new.
		results overlappingPairsWithIndexDo: [:r1 :r2 :i |
			points add: {self normalizePoint: (i@r1). self normalizePoint: (i + 1)@r2}].

		aCanvas fillColor: Color white.
		self
			drawLineson: aCanvas;
			drawPoints: points on: aCanvas;
			gridCanvas: aCanvas points: points;
			labelCanvas: aCanvas points: points].
! !

!BenchmarkWarmupGraph methodsFor: 'drawing' stamp: 'tfel 4/21/2016 16:20'!
drawPoints: points on: aCanvas

	points do: [:p |
		aCanvas
			fillRectangle: (p first - 2 extent: 4@4) color: Color black;
			fillRectangle: (p second - 2 extent: 4@4) color: Color black].! !

!BenchmarkWarmupGraph methodsFor: 'menus' stamp: 'test 4/21/2016 09:03'!
externalName

	^ benchName, '-', self asOop! !

!BenchmarkWarmupGraph methodsFor: 'event handling' stamp: 'tfel 4/21/2016 14:10'!
giveUpKeyboard: anEvent

	anEvent hand newKeyboardFocus: previousFocus.! !

!BenchmarkWarmupGraph methodsFor: 'event handling' stamp: 'tfel 4/21/2016 14:09'!
grabKeyboard: anEvent

	previousFocus := anEvent hand keyboardFocus.
	anEvent hand newKeyboardFocus: self.! !

!BenchmarkWarmupGraph methodsFor: 'drawing' stamp: 'tfel 4/21/2016 17:28'!
gridCanvas: aCanvas points: points

	0 to: self height by: 20 do: [:i |
		aCanvas
			line: 0@i to: self width@i width: 1 color: (Color lightGray lighter alpha: 0.5)]! !

!BenchmarkWarmupGraph methodsFor: 'initialization' stamp: 'tfel 4/21/2016 17:42'!
initialize

	super initialize.
	self
		on: #keyStroke send: #zoom: to: self;
		on: #mouseEnter send: #grabKeyboard: to: self;
		on: #mouseLeave send: #giveUpKeyboard: to: self.! !

!BenchmarkWarmupGraph methodsFor: 'drawing' stamp: 'tfel 4/21/2016 17:40'!
labelCanvas: aCanvas points: points

	| fontHeight font reporter hdr scaleStr scaleStrW |
	font := TextStyle defaultFont.
	fontHeight := font height.
	reporter := BenchmarkSimpleStatisticsReporter new.
	
	hdr := {
		benchName.
		'Iterations: ', (points size + 1).
		resultExtent y asString, ' max msec'.
		resultExtent x asString, ' min msec'.
		results average asFloat asString, ' avg confidence msec +/- ', (reporter significantDigits: (reporter confidenceVariance: results))}.

	hdr withIndexDo: [:label :idx |
		aCanvas drawString: label at: 0@((idx - 1) * fontHeight) font: font color: Color black].

	scaleStr := 'Scale: ', min, ' to ', max.
	scaleStrW := font widthOfString: scaleStr.
	aCanvas drawString: scaleStr at: (self width - scaleStrW)@0 font: font color: Color black.! !

!BenchmarkWarmupGraph methodsFor: 'drawing' stamp: 'tfel 4/21/2016 17:27'!
normalizePoint: aPoint
	| normalX normalY |
	normalX := ((aPoint x / results size - (0.5 / results size)) * self width) floor.
	normalY := (self height - (((aPoint y - min) / (max - min)) * self height)) floor.
	^ normalX@normalY! !

!BenchmarkWarmupGraph methodsFor: 'menus' stamp: 'tfel 4/20/2016 14:55'!
printEPSToFile
	"Ask the user for a filename and print this morph as postscript."
	| fileName psCanvasType psExtension |
	fileName := self externalName asFileName.
	psCanvasType := EPSCanvas.
	psExtension := psCanvasType defaultExtension.
	fileName := UIManager default request: (String streamContents: [ :s |
		s nextPutAll: ('File name? ("{1}" will be added to end)' translated format: {psExtension})])
			initialAnswer: fileName.
	fileName isEmpty
		ifTrue: [^ Beeper beep].
	(fileName endsWith: psExtension)
		ifFalse: [fileName := fileName , psExtension].
	((FileStream newFileNamed: fileName asFileName) converter: TextConverter defaultSystemConverter)
		nextPutAll: self asEPS;
		close! !

!BenchmarkWarmupGraph methodsFor: 'menus' stamp: 'test 4/21/2016 09:05'!
printEPSToFileDirectly
	| fileName  |
	fileName := self externalName asFileName, EPSCanvas defaultExtension.
	((FileStream newFileNamed: fileName asFileName)
		converter: TextConverter defaultSystemConverter)
			nextPutAll: self asEPS;
			close.! !

!BenchmarkWarmupGraph methodsFor: 'accessing' stamp: 'tfel 4/21/2016 16:12'!
results: anObject

	results := anObject collect: #total.
	timers := anObject collect: #timer.

	incGCresults := anObject collect: #incGCtotal.
	fullGCresults := anObject collect: #fullGCtotal.

	min := results first.
	max := min.
	results do: [:result |
		min := result min: min.
		max := result max: max].
	resultExtent := min asFloat @ max asFloat.
	min := 0.! !

!BenchmarkWarmupGraph methodsFor: 'halos and balloon help' stamp: 'tfel 4/21/2016 17:58'!
showBalloon: msgString hand: aHand

	| idx hand |
	hand := aHand ifNil: [self world activeHand].
	(self containsPoint: hand position) ifFalse: [^ nil].
	idx := (((aHand position - self topLeft) x / self width) * results size) floor + 1.
	super
		showBalloon: 'Time: ', (results at: idx) asFloat, String crlf,
					'Incremental GC time: ', (incGCresults at: idx) asFloat, String crlf,
					'Full GC time: ', (fullGCresults at: idx) asFloat, String crlf,
					'Time without GC: ', ((results at: idx) - (fullGCresults at: idx) - (incGCresults at: idx)) asFloat
		hand: aHand.! !

!BenchmarkWarmupGraph methodsFor: 'event handling' stamp: 'tfel 4/21/2016 14:52'!
zoom: aKeyboardEvent 
	| diff |
	(aKeyboardEvent isKeystroke and: [
		aKeyboardEvent controlKeyPressed])
			ifTrue: [
				diff := max - min * 0.2.
				aKeyboardEvent keyCharacter = Character arrowUp
					ifTrue: [
						"min := min + diff."
						max := max - diff].
				aKeyboardEvent keyCharacter = Character arrowDown
					ifTrue: [
						"min := min - diff."
						max := max + diff]].
	self changed.! !

TestCase subclass: #BenchmarkArgumentParserTest
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark-Tests'!

!BenchmarkArgumentParserTest methodsFor: 'running' stamp: 'tfel 5/15/2015 10:18'!
setUp
	parser := BenchmarkArgumentParser new.
	parser harness: BenchmarkSuite.! !

!BenchmarkArgumentParserTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:00'!
testParseArgumentsOnlyBench
	| arguments runnerAndReporter runner reporter runOnly |
	arguments := {#ignored. 'BenchmarkTestBenchmark.benchA' }.
	runnerAndReporter := parser parse: arguments.
	
	runner   := runnerAndReporter first.
	reporter := runnerAndReporter second.
	
	self assert: runner notNil.
	self assert: reporter notNil.
	
	self assert: (runner suite isKindOf: BenchmarkTestBenchmark).
	runOnly := runner suite selectedBenchmarks.
	self assert: 1 equals: runOnly size.
	self assert: (runOnly includes: #benchA).
! !

!BenchmarkArgumentParserTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:00'!
testParseArgumentsOnlySuite
	| arguments runnerAndReporter runner reporter |
	arguments := {#ignored. 'BenchmarkTestBenchmark' }.
	runnerAndReporter := parser parse: arguments.
	
	runner   := runnerAndReporter first.
	reporter := runnerAndReporter second.
	
	self assert: runner notNil.
	self assert: reporter notNil.
	
	self assert: (runner suite isKindOf: BenchmarkTestBenchmark).
	self assert: runner suite selectedBenchmarks isNil.
! !

!BenchmarkArgumentParserTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:00'!
testParseArgumentsReporterSuiteIterations
	| arguments runnerAndReporter runner reporter |
	arguments := {#ignored. 'BenchmarkSimpleStatisticsReporter'. 'BenchmarkTestBenchmark'. '13'. }.
	runnerAndReporter := parser parse: arguments.
	
	runner   := runnerAndReporter first.
	reporter := runnerAndReporter second.
	
	self assert: runner notNil.
	self assert: reporter notNil.
	
	self assert: (reporter isKindOf: BenchmarkSimpleStatisticsReporter).
	self assert: (runner suite isKindOf: BenchmarkTestBenchmark).
	self assert: runner suite selectedBenchmarks isNil.
	
	self assert: 13 equals: runner iterations.	! !

!BenchmarkArgumentParserTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:00'!
testParseArgumentsRunnerReporterSuiteIterations
	| arguments runnerAndReporter runner reporter |
	arguments := {#ignored. 'BenchmarkTestSuite'. 'BenchmarkSimpleStatisticsReporter'. 'BenchmarkTestBenchmark'. '13'. }.
	runnerAndReporter := parser parse: arguments.
	
	runner   := runnerAndReporter first.
	reporter := runnerAndReporter second.
	
	self assert: runner notNil.
	self assert: reporter notNil.
	
	self assert: (runner isKindOf: BenchmarkTestSuite).
	self assert: (reporter isKindOf: BenchmarkSimpleStatisticsReporter).
	self assert: (runner suite isKindOf: BenchmarkTestBenchmark).
	self assert: runner suite selectedBenchmarks isNil.
	
	self assert: 13 equals: runner iterations.! !

!BenchmarkArgumentParserTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:00'!
testParseArgumentsRunnerSuiteIterations
	| arguments runnerAndReporter runner reporter |
	arguments := {#ignored. 'BenchmarkTestSuite'. 'BenchmarkTestBenchmark'. '13'. }.
	runnerAndReporter := parser parse: arguments.
	
	runner   := runnerAndReporter first.
	reporter := runnerAndReporter second.
	
	self assert: runner notNil.
	self assert: reporter notNil.
	
	self assert: (runner isKindOf: BenchmarkTestSuite).
	self assert: (runner suite isKindOf: BenchmarkTestBenchmark).
	self assert: runner suite selectedBenchmarks isNil.
	
	self assert: 13 equals: runner iterations.! !

!BenchmarkArgumentParserTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:00'!
testParseArgumentsSuiteAndIterations
	| arguments runnerAndReporter runner reporter |
	arguments := {#ignored. 'BenchmarkTestBenchmark'. '13' }.
	runnerAndReporter := parser parse: arguments.
	
	runner   := runnerAndReporter first.
	reporter := runnerAndReporter second.
	
	self assert: runner notNil.
	self assert: reporter notNil.
	
	self assert: (runner suite isKindOf: BenchmarkTestBenchmark).
	self assert: runner suite selectedBenchmarks isNil.
	
	self assert: 13 equals: runner iterations.! !

!BenchmarkArgumentParserTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:00'!
testParseArgumentsSuiteIterationsProcesses
	| arguments runnerAndReporter runner reporter |
	arguments := {#ignored. 'BenchmarkTestBenchmark'. '13'. '91' }.
	runnerAndReporter := parser parse: arguments.
	
	runner   := runnerAndReporter first.
	reporter := runnerAndReporter second.
	
	self assert: runner notNil.
	self assert: reporter notNil.
	
	self assert: (runner suite isKindOf: BenchmarkTestBenchmark).
	self assert: runner suite selectedBenchmarks isNil.
	
	self assert: 13 equals: runner iterations.
	self assert: 91 equals: runner processes.
! !

!BenchmarkArgumentParserTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:00'!
testParseArgumentsSuiteIterationsProcessesProblemSize
	| arguments runnerAndReporter runner reporter |
	arguments := {#ignored. 'BenchmarkTestBenchmark'. '13'. '91'. 'SSS' }.
	runnerAndReporter := parser parse: arguments.
	
	runner   := runnerAndReporter first.
	reporter := runnerAndReporter second.
	
	self assert: runner notNil.
	self assert: reporter notNil.
	
	self assert: (runner suite isKindOf: BenchmarkTestBenchmark).
	self assert: runner suite selectedBenchmarks isNil.
	
	self assert: 13 equals: runner iterations.
	self assert: 91 equals: runner processes.
	self assert: 'SSS' equals: runner problemSize.
! !

!BenchmarkArgumentParserTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:01'!
testParseBenchmarkOrSuite
	| example1 example2 example3 example4 example5 |
	example1 := 'String>>findTokens:'.
	example2 := 'BenchmarkTestBenchmark'.
	example3 := { BenchmarkTestBenchmark. #benchA }.
	example4 := BenchmarkTestBenchmark.
	example5 := 'String.findTokens:'. ". (dot) notation is required to avoid quoting in bash"
	
	self assert: { String. #findTokens: }    equals: (parser parseBenchmarkOrSuite: example1).
	self assert: BenchmarkTestBenchmark              equals: (parser parseBenchmarkOrSuite: example2).
	self assert: { BenchmarkTestBenchmark. #benchA } equals: (parser parseBenchmarkOrSuite: example3).
	self assert: BenchmarkTestBenchmark              equals: (parser parseBenchmarkOrSuite: example4).
	self assert: { String. #findTokens: }    equals: (parser parseBenchmarkOrSuite: example5).
	
	"What to do when the input is not a symbol, array, or class?"
	
	"What to do when the class does not exist"
	self should: [parser parseBenchmarkOrSuite: 'FooBarClassThatDoesNotExist'] raise: Error.! !

TestCase subclass: #BenchmarkReporterTest
	instanceVariableNames: 'runner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark-Tests'!

!BenchmarkReporterTest methodsFor: 'running' stamp: 'tfel 5/15/2015 11:06'!
setUp
	runner := BenchmarkTestSuiteBenchmarkForAutosizing run.! !

!BenchmarkReporterTest methodsFor: 'compatibility Pharo 1.4 vs. 2.0' stamp: 'StefanMarr 2/13/2013 00:58'!
string: str includes: subStr
	"To be compatible with Pharo 1.4 and 2.0"
	(str respondsTo: #includesSubstring:)
		ifTrue:  [ ^ str includesSubstring: subStr ] "2.0"
		ifFalse: [ ^ str includesSubString: subStr ] "1.4"! !

!BenchmarkReporterTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 10:18'!
testContentOfStream
	"Hm, how to test that robustly?"
	| reporter stream out |
	stream := TextStream on: String new.
	reporter := BenchmarkReporter reportFor: runner on: stream.
	
	out := stream contents.
	
	self assert: (self string: out includes: 'Small').
	self assert: (self string: out includes: 'Big').! !

!BenchmarkReporterTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:06'!
testConvenienceReportOnRunner
	| stream out |
	stream := TextStream on: String new.
	
	"That should just work, cannot really check whether it is displayed anywhere."
	BenchmarkTestSuiteBenchmarkForAutosizing run report.
	
	"Check whether it reported as expected"
	BenchmarkTestSuiteBenchmarkForAutosizing run reportOn: stream.
	
	out := stream contents.
	
	self assert: (self string: out includes: 'Small').
	self assert: (self string: out includes: 'Big').! !

TestCase subclass: #BenchmarkResultTest
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark-Tests'!

!BenchmarkResultTest commentStamp: 'StefanMarr 3/18/2011 23:29' prior: 0!
This test specifies the data stored in a result object.
The result object does not actually provide behavior on its own.!

!BenchmarkResultTest methodsFor: 'running' stamp: 'tfel 5/15/2015 11:06'!
setUp
	| runner |
	runner := BenchmarkTestSuite execute: BenchmarkTestSuiteBenchmark new.
	result := (runner results at: #DoNothing) at: 1.! !

!BenchmarkResultTest methodsFor: 'tests' stamp: ''!
testBenchmarkName
	self assert: (result benchmarkName isKindOf: String)! !

!BenchmarkResultTest methodsFor: 'tests' stamp: ''!
testCriteria
	self assert: (result criteria respondsTo: #at:).
	self assert: (result criteria size > 0).! !

!BenchmarkResultTest methodsFor: 'tests' stamp: ''!
testSuite
	self assert: result suite notNil! !

!BenchmarkResultTest methodsFor: 'tests' stamp: ''!
testTotal
	self assert: (result total isKindOf: Number)! !

TestCase subclass: #BenchmarkSuiteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark-Tests'!

BenchmarkSuiteTest subclass: #BenchmarkAutosizeSuiteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark-Tests'!

!BenchmarkAutosizeSuiteTest class methodsFor: 'as yet unclassified' stamp: ''!
shouldInheritSelectors
	^ true! !

!BenchmarkAutosizeSuiteTest methodsFor: 'helper' stamp: 'tfel 5/15/2015 10:56'!
runnerClass
	^ BenchmarkTestAutosizeSuite! !

!BenchmarkAutosizeSuiteTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:06'!
testAutosizing
	"Ensure that the runtime is automatically sized up to a predefined value"
	| runner results big small runTime benchmarkSum |
	
	runner := self runnerClass new.
	
	"sanity check for target time"
	"Not checked since we reduced the targetTime for testing:
	 self assert: self runnerClass defaultTargetTime equals: runner targetTime."
	self assert: (self runnerClass defaultTargetTime > 250).
	
	runner iterations: 3.
	  
	runner suite: BenchmarkTestSuiteBenchmarkForAutosizing new.
	
	"Execute the benchmarks and take the overall time it takes"
	runTime := Time millisecondClockValue.
	results := runner execute.
	runTime := Time millisecondClockValue - runTime.
	
	"There should be three benchmarks"
	self assert: 3 equals: results size.
	self assert: (results includesKey: #baseBenchmark).
	big := results at: #Big.
	small := results at: #Small.
	
	self assert: (big respondsTo: #at:).
	self assert: 3 equals: big size.
	
	self assert: (runner targetTime <= (big at: 1) total).
	self assert: (runner targetTime <= (small at: 1) total).
	
	"Calculate the sum of all measurements"
	benchmarkSum := big inject: 0 into: [:sum :result| sum + result total].
	benchmarkSum := small inject: benchmarkSum into: [:sum :result| sum + result total].
	
	"And now make sure that we not try to find the problem size for every but only the first run"
	self assert: (benchmarkSum * 2) > runTime.
	
! !

!BenchmarkAutosizeSuiteTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:06'!
testAutosizingBaseBenchmark
	"Ensure that baseBenchmarks are not delivering any data since I do not see how that could be done nicely"
	| runner results |
	runner := self runnerClass new.
	runner iterations: 3.
	runner suite: BenchmarkTestSuiteBenchmarkForAutosizing new.
	
	"Execute the benchmarks and take the overall time it takes"
	results := runner execute.
	
	"There should be two benchmarks"
	self assert: 3 equals: results size.
	self assert: 0 equals: ((results at: #baseBenchmark) at: 1) total.
	
! !

!BenchmarkAutosizeSuiteTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:03'!
testBaseBenchmark
	"Different from base test: Ensure the base benchmark is NOT executed when available"
	
	| runner |
	runner := self runnerClass execute: BenchmarkTestBenchmarkWithBaseBenchmark new.

	self deny: runner baseBenchmarkExecuted  ! !

!BenchmarkAutosizeSuiteTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:06'!
testExecute
	"This test is slightly different from the one in the base class"
	| runner results performedBenchmarks |
	runner := self runnerClass new.
	runner suite: BenchmarkTestSuiteBenchmarkForPerfromBenchmark new.
	results := runner execute.
	
	performedBenchmarks := runner performedBenchmarks.
		
	self assert: 4 equals: performedBenchmarks size.				"Different from base test"
	self deny: (performedBenchmarks includes: #baseBenchmark).	"Different from base test"
	
	self assert: (results respondsTo: #at:).
	
	"But still we get a result" "Different from base test"
	self assert: (((results at: #baseBenchmark) at: 1) isKindOf: BenchmarkResult).! !

!BenchmarkAutosizeSuiteTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:06'!
testIterations
	| runner |
	"This test is different then the one in the base class, it is not direct, but just looks at the results"
	
	" simple scenario should default to 1 run for now "
	runner := self runnerClass execute: BenchmarkTestSuiteBenchmark new.
	
	self assert: 1 equals: (runner results at: #NotifyRunner) size.
	
	" but we can also be more fancy and set the number of iterations "
	runner := self runnerClass new.
	runner suite: BenchmarkTestSuiteBenchmark new.
	
	"first check again that the default is as expected"
	self assert: 1 equals: runner iterations.  
	
	runner iterations: 10.
	self assert: runner iterations equals: 10.
	
	runner execute.
	
	self assert: 10 equals: (runner results at: #NotifyRunner) size.! !

!BenchmarkSuiteTest methodsFor: 'helper' stamp: 'tfel 5/15/2015 10:57'!
runnerClass
	^ BenchmarkTestSuite! !

!BenchmarkSuiteTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:03'!
testBaseBenchmark
	"Ensure the base benchmark is executed when available"
	
	| runner |
	runner := self runnerClass execute: BenchmarkTestBenchmarkWithBaseBenchmark new.

	self assert: runner baseBenchmarkExecuted  ! !

!BenchmarkSuiteTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:01'!
testBaseBenchmarkNone
	"Ensure that not having a base benchmark does not pose a problem"

	| runner |
	runner := self runnerClass execute: BenchmarkTestBenchmark new.

	self deny: runner baseBenchmarkExecuted  ! !

!BenchmarkSuiteTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:01'!
testBenchmarkWithMultipleCriteraTimers
	"Check whether the benchmark benchWithMultipleCriteria, really results in different unrelated timings"
	| runner result |
	runner := self runnerClass execute: BenchmarkTestBenchmark new.
	
	result := (runner results at: #WithMultipleCriteria) at: 1.
	self assert: (result isKindOf: BenchmarkResult).
	
	self assert: result benchmarkName equals: #WithMultipleCriteria.
	self assert: (result total >= 50).
	
	self assert: (result criteria notNil).
	self assert: (result criteria respondsTo: #at:).
	
	self assert: ((result criteria at: 't1') totalTime >= 10).
	self assert: ((result criteria at: 't2') totalTime >= 25).
	self assert: ((result criteria at: 't3') totalTime >= 50).
	! !

!BenchmarkSuiteTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:03'!
testClassExecute
	| runner |
	runner := self runnerClass execute: BenchmarkTestBenchmarkWithBaseBenchmark new.
	
	self assert: (runner isKindOf: self runnerClass).! !

!BenchmarkSuiteTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:06'!
testExecute
	"Ensure all benchmarks are run, including the baseBenchmark and the results are returned"
	| runner results performedBenchmarks |
	runner := self runnerClass new.
	runner suite: BenchmarkTestSuiteBenchmarkForPerfromBenchmark new.
	results := runner execute.
	
	performedBenchmarks := runner performedBenchmarks.
		
	self assert: 5 equals: performedBenchmarks size.
	self assert: (performedBenchmarks includes: #baseBenchmark).
	
	self assert: (results respondsTo: #at:).
	self assert: (((results at: #baseBenchmark) at: 1) isKindOf: BenchmarkResult).! !

!BenchmarkSuiteTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 10:58'!
testIterations
	| runner |
	" simple scenario should default to 1 run for now "
	runner := self runnerClass execute: BenchmarkTestRunnerSuite new.
	
	self assert: runner countWasExecuted equals: 1.
	
	" but we can also be more fancy and set the number of iterations "
	runner := self runnerClass new.
	runner suite: BenchmarkTestRunnerSuite new.
	
	"first check again that the default is as expected"
	self assert: runner iterations equals: 1.  
	
	runner iterations: 10.
	self assert: 10 equals: runner iterations.
	
	runner execute.
	
	self assert: 10 equals: runner countWasExecuted.! !

!BenchmarkSuiteTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:06'!
testPerformBenchmark
	"Ensure that performBenchmark executes all the defined #bench methods, but for instance not #Bench"
	
	| runner performedBenchmarks |
	runner := self runnerClass execute: BenchmarkTestSuiteBenchmarkForPerfromBenchmark new.
	performedBenchmarks := runner performedBenchmarks.

	self assert: (performedBenchmarks includes: #benchAfsdfsdfsdf).
	self assert: (performedBenchmarks includes: #benchBsdfasereSDSfsdfsdfs).
	self assert: (performedBenchmarks includes: #benchC).
	self assert: (performedBenchmarks includes: #benchZZ).

	self deny: (performedBenchmarks includes: #BenchShouldNotBeExecuted).! !

!BenchmarkSuiteTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:01'!
testResultStructure
	| runner results resultA resultB suite |
	suite := BenchmarkTestBenchmark new.
	runner := self runnerClass execute: suite.
	results := runner results.
	
	"Don't care whether it is a dictionary, but at least it should present us something that maps benchmark names to result objects"
	self assert: (results respondsTo: #at:).

	resultA := (results at: #A) at: 1.
	resultB := (results at: #B) at: 1.


	self assert: (resultA isKindOf: BenchmarkResult).
	self assert: (resultB isKindOf: BenchmarkResult).
	self assert: (((results at: #C) at: 1) isKindOf: BenchmarkResult).
	
	"Make sure some properties of the result objects is ensured"
	self assert: resultA total > 0.
	self assert: #A equals: resultA benchmarkName.
	self assert: suite equals: resultA suite.
	self assert: 1 equals: resultA criteria size.
	
	self assert: resultB total > 0.
	self assert: #B equals: resultB benchmarkName.
	self assert: suite equals: resultB suite.
	self assert: 1 equals: resultB criteria size.
	"Testing for multi-criteria results somewhere else"! !

!BenchmarkSuiteTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 10:53'!
testShouldShowUsage
	| example1 example2 example3 example4 |
	example1 := { #ignored. '--help' }.
	example2 := { #ignored. }.
	example3 := { #ignored. '-?'}.
	example4 := { #ignored. 1. 2. }.
	
	self assert: (BenchmarkSuite shouldShowUsage: example1).
	self assert: (BenchmarkSuite shouldShowUsage: example2).
	self assert: (BenchmarkSuite shouldShowUsage: example3).
	self deny:   (BenchmarkSuite shouldShowUsage: example4).
! !

!BenchmarkSuiteTest methodsFor: 'tests' stamp: ''!
testTimer
	"Simple test whether a timer is created and it is from the expected class.
	 This test is very basic, other tests like testBenchmarkWithMultipleCirteria* need to cover the rest"
	| runner timer |
	runner := self runnerClass new.
	timer := runner createTimer: #foo.

	self assert: timer name equals: #foo.
	self assert: (timer isKindOf: self runnerClass defaultTimer).  ! !

BenchmarkSuiteTest subclass: #BenchmarkWeakScalingSuiteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark-Tests'!

!BenchmarkWeakScalingSuiteTest class methodsFor: 'as yet unclassified' stamp: ''!
shouldInheritSelectors
	^ true! !

!BenchmarkWeakScalingSuiteTest methodsFor: 'helper' stamp: 'tfel 5/15/2015 11:05'!
runnerClass
	^ BenchmarkTestWeakScalingSuite! !

!BenchmarkWeakScalingSuiteTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 10:58'!
testInnerIterations
	"Test the semantics of the inner loop parameter"
	| runner results |
	
	"Setup"
	runner := self runnerClass new.
	runner iterations: 1.
	runner innerIterations: 1.  
	runner processes: 10.
	runner suite: BenchmarkTestRunnerSuite new.
	results := runner execute.
	
	self assert: 10 equals: runner countWasExecuted.
	self assert: 1  equals: (results at: #NotifyRunner) size.
	
	runner := self runnerClass new.
	runner iterations: 2.
	runner innerIterations: 1.  
	runner processes: 10.
	runner suite: BenchmarkTestRunnerSuite new.
	results := runner execute.
	
	self assert: 20 equals: runner countWasExecuted.
	self assert: 2  equals: (results at: #NotifyRunner) size.
	
	
	runner := self runnerClass new.
	runner iterations: 2.
	runner innerIterations: 4.  
	runner processes: 10.
	runner suite: BenchmarkTestRunnerSuite new.
	results := runner execute.
	
	self assert: (20 * 4) equals: runner countWasExecuted.
	self assert: 2  equals: (results at: #NotifyRunner) size.
	
	runner := self runnerClass new.
	runner iterations: 4.
	runner innerIterations: 7.  
	runner processes: 10.
	runner suite: BenchmarkTestRunnerSuite new.
	results := runner execute.
	
	self assert: (40 * 7) equals: runner countWasExecuted.
	self assert: 4           equals: (results at: #NotifyRunner) size.! !

!BenchmarkWeakScalingSuiteTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 10:58'!
testWeakScaling3Processes
	"test with small number of processes and varying number of iterations"
	| runner results |
	
	"Setup for 2 iteration, and 3 process"
	runner := self runnerClass new.
	runner iterations: 2.
	runner processes: 3.
	runner suite: BenchmarkTestRunnerSuite new.
	results := runner execute.
	
	self assert: 6 equals: runner countWasExecuted.
	self assert: 2 equals: (results at: #NotifyRunner) size.! !

!BenchmarkWeakScalingSuiteTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 10:58'!
testWeakScalingFewProcesses
	"test with small number of processes and varying number of iterations"
	| runner results |
	
	"Setup for 1 iteration, and 1 process"
	runner := self runnerClass new.
	runner iterations: 1.
	runner processes: 1.
	runner suite: BenchmarkTestRunnerSuite new.
	results := runner execute.
	
	self assert: 1 equals: runner countWasExecuted.
	! !

!BenchmarkWeakScalingSuiteTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 10:58'!
testWeakScalingManyProcesses
	"test with large number of processes and varying number of iterations"
	| runner results |
	
	"Setup"
	runner := self runnerClass new.
	runner iterations: 1.
	runner processes: 10.
	runner suite: BenchmarkTestRunnerSuite new.
	results := runner execute.
	
	self assert: 10 equals: runner countWasExecuted.
	self assert: 1  equals: (results at: #NotifyRunner) size.
	
	runner := self runnerClass new.
	runner iterations: 2.
	runner processes: 10.
	runner suite: BenchmarkTestRunnerSuite new.
	results := runner execute.
	
	self assert: 20 equals: runner countWasExecuted.
	self assert: 2  equals: (results at: #NotifyRunner) size.
	
	runner := self runnerClass new.
	runner iterations: 4.
	runner processes: 10.
	runner suite: BenchmarkTestRunnerSuite new.
	results := runner execute.
	
	self assert: 40 equals: runner countWasExecuted.
	self assert: 4  equals: (results at: #NotifyRunner) size.! !

TestCase subclass: #BenchmarkTest
	instanceVariableNames: 'didSetUpBenchB didTearDownBenchC'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark-Tests'!

!BenchmarkTest methodsFor: 'running' stamp: 'tfel 5/15/2015 10:55'!
setUp
	"Necessary for Squeak 4.2 compatibility, since method anotations are not supported in the base image."
	(self respondsTo:  #timeout:) ifTrue: [
		self timeout: 300.
	].! !

!BenchmarkTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 10:55'!
testAllBenchmarksForReturningThemSelf
	"This is a regression test to ensure that the old behavior worked in the first place"
	| allSuites |
	allSuites := { SMarkCompiler. SMarkLoops }.
	
	allSuites do: [:suite |
		suite isAbstractClass ifFalse: [
			| runner results |
			Transcript show: (suite class name asString); cr.
			runner := suite run.
			results := runner results.
			self assert: (runner isKindOf: suite defaultRunner).
			self assert: 1 equals: runner iterations.
			self assert: (results size > 0).
		].
	].! !

!BenchmarkTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 10:55'!
testBasicRun
	| runner results benchResult result |
	
	runner := SMarkLoops run.
	results := runner results.
	result := (results at: #IntLoop).
	
	self assert: (result isKindOf: Collection).
	self assert: result size equals: 1.
	
	benchResult := result at: 1.
	self assert: (benchResult isKindOf: BenchmarkResult).
	self assert: (benchResult total notNil).
	! !

!BenchmarkTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 10:46'!
testBenchmarkNameForSelector
	| suite |
	suite := Benchmark new.
	
	self assert: (suite benchmarkNameForSelector: #benchSomething) equals: #Something.
	self assert: (suite benchmarkNameForSelector: #benchsomeThingElse) equals: #someThingElse.
	
	self assert: (suite benchmarkNameForSelector: #nobenchSomeThing) equals: #nobenchSomeThing.
	self assert: (suite benchmarkNameForSelector: #BenchSomeThing) equals: #BenchSomeThing.! !

!BenchmarkTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:01'!
testClassRun
	| runner |
	
	runner := BenchmarkTestBenchmark run.
	self assert: (runner isKindOf: BenchmarkTestBenchmark defaultRunner).
	self deny: runner results isNil    ! !

!BenchmarkTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:01'!
testCleanUpInstanceVariables
	| suite |
	suite := BenchmarkTestBenchmark new.
	suite runner: #dummy.
	
	self assert: suite runner	equals: #dummy.
	self assert: suite a			equals: 1.
	self assert: suite c			equals: #three.
				
	suite cleanUpInstanceVariables.
	
	self assert: suite runner	equals: #dummy.
	self assert: suite a			equals: nil.
	self assert: suite b			equals: nil.
	self assert: suite c			equals: nil.
	self assert: suite d			equals: nil.
! !

!BenchmarkTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:01'!
testCustomSetUp
	| suite runner |
	
	suite := BenchmarkTestBenchmark new.
	runner := BenchmarkTestSuite execute: suite.  
	
	self assert: runner hasSetUpBenchB! !

!BenchmarkTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:01'!
testCustomTearDown
	| suite runner |
	suite := BenchmarkTestBenchmark new.
	runner := BenchmarkTestSuite execute: suite.  
	
	self assert: runner hasTearDownBenchC.! !

!BenchmarkTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:01'!
testSetUp
	| suite runner |
	suite := BenchmarkTestBenchmark new.
	
	self assert: suite a			equals: 1.
	self assert: suite b			equals: 2.
	self assert: suite c			equals: #three.
	
	runner := BenchmarkTestSuite execute: suite.
	
	"Make sure they are reset after each run,
	 well we test just whether they are reset after the final run"
	self assert: suite a			equals: nil.
	self assert: suite b			equals: nil.
	self assert: suite c			equals: nil.
	self assert: suite d			equals: nil.

	"Make sure setUp was called 4 times."
	
	self assert: 4 equals: runner setUpCount.! !

!BenchmarkTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:01'!
testSetupAndTeaddownCalledForEveryBenchForEveryIteration
	| suite runner |

	"Setup needs to be executed for every benchmark on every iteration.
	 Test with iterations: 1"
	suite := BenchmarkTestBenchmark new.
	runner := BenchmarkTestSuite execute: suite with: 1.

	self assert: 4 equals: runner setUpCount.
	self assert: 4 equals: runner tearDownCount.
	
	"Setup needs to be executed for every benchmark on every iteration.
	 Test with iterations: 4"
	suite := BenchmarkTestBenchmark new.
	runner := BenchmarkTestSuite execute: suite with: 4.

	self assert: (4 * 4) equals: runner setUpCount.
	self assert: (4 * 4) equals: runner tearDownCount.
	
	"Test with iterations: 10"
	suite := BenchmarkTestBenchmark new.
	runner := BenchmarkTestSuite execute: suite with: 10.
	self assert: (4 * 10) equals: runner setUpCount.
	self assert: (4 * 10) equals: runner tearDownCount.! !

!BenchmarkTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 10:46'!
testShouldRunSelector
	| suite |
	suite := Benchmark new.
	
	self assert: (suite shouldRunSelector: #benchSomething).
	self assert: (suite shouldRunSelector: #benchsomeThingElse).
	
	self deny: (suite shouldRunSelector: #nobenchSomeThing).
	self deny: (suite shouldRunSelector: #BenchSomeThing).! !

!BenchmarkTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 11:01'!
testTearDown
	| suite runner |
	suite := BenchmarkTestBenchmark new.
	runner := BenchmarkTestSuite execute: suite.  
	
	self assert: 4 equals: runner tearDownCount.! !

TestCase subclass: #BenchmarkTimerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark-Tests'!

!BenchmarkTimerTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 10:28'!
testName
	| timer |
	timer := BenchmarkTimer new.
	
	self assert: timer name equals: nil.
	
	timer name: #foo.
	
	self assert: timer name equals: #foo.! !

!BenchmarkTimerTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 10:28'!
testReset
	| timer |
	timer := BenchmarkTimer new.
	
	timer start.
	(Delay forMilliseconds: 10) wait.
	timer stop.
	
	self assert: (timer totalTime >= 10).
	
	timer reset.
	
	self assert: timer totalTime equals: 0.! !

!BenchmarkTimerTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 10:28'!
testStartStop
	| timer |
	timer := BenchmarkTimer new.
	
	self assert: timer totalTime equals: 0.
	
	timer start.
	
	(Delay forMilliseconds: 10) wait.
	
	timer stop.
	
	self assert: (timer totalTime >= 10).! !

!BenchmarkTimerTest methodsFor: 'tests' stamp: 'tfel 5/15/2015 10:28'!
testTotalTimeWithResume
	| timer |
	timer := BenchmarkTimer new.
	self assert: timer totalTime equals: 0.
	
	timer start.
	(Delay forMilliseconds: 10) wait.
	timer stop.
	
	self assert: (timer totalTime >= 10).
	
	timer start.
	(Delay forMilliseconds: 10) wait.
	timer stop.
	
	self assert: (timer totalTime >= 20).
	
	timer start.
	(Delay forMilliseconds: 10) wait.
	timer stop.
	
	self assert: (timer totalTime >= 30).! !

Object subclass: #Benchmark
	instanceVariableNames: 'runner selectedBenchmarks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark'!

Benchmark class
	instanceVariableNames: 'history'!

!Benchmark commentStamp: '<historical>' prior: 0!
A Benchmark Suite is a set of benchmarks and it knows what exactly needs to be executed.
However, it does not really know how to execute it.
It knows all the magic, that is, how to set up and tear down the environment for the benchmarks, but does not have the knowledge of how many iterations need to be done and how to evaluate any results that might be produced.

Please see also SMarkHarness, which is the main class relevant for users to execute benchmarks with SMark.

Usage:

Choose a suite (i.e. one of my subclasses) and use the class-side #run or run: messages.

To get an example print the result of the following expression:
	
	SMarkCompiler run: 10
	
	SMarkLoops runOnly: #benchArrayAccess
!

Benchmark class
	instanceVariableNames: 'history'!

!Benchmark class methodsFor: 'benchmarking' stamp: 'tfel 5/11/2015 16:20'!
benchmarkSelectors

	^(self selectors asArray select: [ :each | 
		(each beginsWith: 'bench') and: [ each numArgs isZero ] ]) sort! !

!Benchmark class methodsFor: 'defaults' stamp: ''!
defaultProblemSize
	^ nil! !

!Benchmark class methodsFor: 'defaults' stamp: 'tfel 5/15/2015 10:47'!
defaultRunner

	^ BenchmarkSuite! !

!Benchmark class methodsFor: 'history' stamp: 'tfel 5/11/2015 19:42'!
historyAdd: aResult

	history ifNil: [history := IdentityDictionary new].
	history add: aResult.
	history size > self maxHistory ifTrue: [history := history copyWithoutFirst].! !

!Benchmark class methodsFor: 'history' stamp: 'tfel 5/11/2015 19:46'!
historyAdd: aResult at: selector
	| list |
	history ifNil: [history := IdentityDictionary new].
	list := history at: selector ifAbsentPut: OrderedCollection new.
	list add: aResult.
	list size > self maxHistory ifTrue: [
		history at: selector put: list copyWithoutFirst].! !

!Benchmark class methodsFor: 'history' stamp: 'tfel 5/11/2015 20:12'!
historyAt: aSelector

	history ifNil: [^ nil].
	^ history at: aSelector ifAbsent: [nil]! !

!Benchmark class methodsFor: 'testing' stamp: 'tfel 5/11/2015 16:06'!
isAbstract

	^ self name = #SMarkSuite! !

!Benchmark class methodsFor: 'benchmarking' stamp: ''!
isAbstractClass
	"This is a hack that is necessary in Squeak since it does not provide #isAbstractClass.
	 Actually this class is supposed to be abstract, but well, inheritance..."
	
	^ false! !

!Benchmark class methodsFor: 'history' stamp: 'tfel 5/11/2015 19:42'!
maxHistory
	"The maximum amount of history to keep"
	^ 10! !

!Benchmark class methodsFor: 'platform support' stamp: 'StefanMarr 4/5/2012 22:20'!
onCog: cogSpecificBlock else: general
	^ (Smalltalk vm isRunningCogit)
		ifTrue:  [cogSpecificBlock value]
		ifFalse: [general value]! !

!Benchmark class methodsFor: 'profiling' stamp: 'CamilloBruni 1/28/2013 18:22'!
profile: aSelector
	^ self profileRunner 
		execute: self new selector: aSelector.! !

!Benchmark class methodsFor: 'profiling' stamp: 'CamilloBruni 1/28/2013 18:30'!
profile: aSelector iterations: nIterations
	^ self profileRunner 
		execute: self new selector: aSelector iterations: nIterations.! !

!Benchmark class methodsFor: 'profiling' stamp: 'CamilloBruni 1/28/2013 18:21'!
profileAll
	^ self profileRunner 
		execute: self new.! !

!Benchmark class methodsFor: 'profiling' stamp: 'tfel 5/15/2015 10:27'!
profileRunner
	^ BenchmarkProfileSuite! !

!Benchmark class methodsFor: 'benchmarking' stamp: 'StephaneDucasse 6/16/2013 12:11'!
run
	"Execute the suite one time."
	^ self defaultRunner execute: self new.! !

!Benchmark class methodsFor: 'benchmarking' stamp: 'StephaneDucasse 6/16/2013 12:11'!
run: nIterations
	"Execute the suite a given number of iterations."
	
	^ self defaultRunner execute: self new with: nIterations.! !

!Benchmark class methodsFor: 'benchmarking' stamp: 'StefanMarr 6/30/2013 00:57'!
runOnly: aSelector
  "aSelector should refer to a benchmark method.
   Example:
     SMarkLoops runOnly: #benchFloatLoop
  "
  ^ self defaultRunner execute: (self new runOnly: aSelector)! !

!Benchmark class methodsFor: 'benchmarking' stamp: 'StephaneDucasse 6/16/2013 21:03'!
runOnly: aSelector iterations: anInteger
	"Execute only the bench name aSelector from the suite."
	
	^ self defaultRunner execute: (self new runOnly: aSelector) with: anInteger! !

!Benchmark methodsFor: 'helper' stamp: ''!
benchmarkNameForSelector: selector
	"Extracts the actual name of the benchmark from the selector"
	(selector beginsWith: #bench) ifTrue: [ ^ selector copyFrom: 6 to: selector size].
	^ selector asSymbol
	! !

!Benchmark methodsFor: 'running' stamp: 'MartinDias 3/12/2014 15:52'!
cleanUpInstanceVariables
	"Make sure all variables that are 'user variables' get cleaned"
	
	(self class allInstVarNames copyWithoutAll: self instanceVariablesToPreserve) do: [ :name |
		self instVarNamed: name put: nil ]! !

!Benchmark methodsFor: 'running' stamp: 'MartinDias 3/12/2014 15:48'!
instanceVariablesToPreserve
	^ #(runner)! !

!Benchmark methodsFor: 'benchmarking' stamp: ''!
performCustomSelector: aSelector with: aPrefix
	| customSelector |
	customSelector := (aPrefix, aSelector capitalized) asSymbol.
	(self respondsTo: customSelector) ifTrue: [ 
		self perform: customSelector].! !

!Benchmark methodsFor: 'benchmarking' stamp: 'StefanMarr 5/8/2013 13:55'!
problemSize
	<omniUnenforced> "Hint for the OMOP that it is part of the meta infrastructure"
	runner             ifNil: [^ self class defaultProblemSize].
	runner problemSize ifNil: [^ self class defaultProblemSize].
	^ runner problemSize! !

!Benchmark methodsFor: 'benchmarking' stamp: 'ReinoutStevens 12/6/2011 14:31'!
processResult: anObject withTimer: aSMarkTimer
	"subclass responsability. You can verify your results here, or do things with the timer."
	^self.! !

!Benchmark methodsFor: 'benchmarking' stamp: 'tfel 6/2/2015 10:01'!
run
	"Executes all the benchmarks in the suite, 
	 coordinating with the runner when necessary"
	
	| potentialBenchmarkSelectors |
	selectedBenchmarks
		ifNotNil: [ potentialBenchmarkSelectors := selectedBenchmarks copy ]
		ifNil:    [ potentialBenchmarkSelectors := self class allSelectors ].				
	potentialBenchmarkSelectors do: [:selector |
		(self shouldRunSelector: selector) ifTrue: [
			[self
				setUp;
				performCustomSelector: selector with: #setUp.
			runner performBenchmark: selector] ensure: [
				self
					performCustomSelector: selector with: #tearDown;
					tearDown;
					cleanUpInstanceVariables]]].
! !

!Benchmark methodsFor: 'benchmarking' stamp: ''!
runBenchmark: aSelector
	
	[self setUp.
	 self performCustomSelector: aSelector with: #setUp.
	 runner timedBenchmarkExecution: aSelector] ensure: [
		self performCustomSelector: aSelector with: #tearDown.
		self tearDown.
		self cleanUpInstanceVariables]! !

!Benchmark methodsFor: 'benchmarking' stamp: ''!
runOnly: aSymbol
	selectedBenchmarks := IdentitySet newFrom: { aSymbol }.! !

!Benchmark methodsFor: 'accessing' stamp: ''!
runner
	^ runner! !

!Benchmark methodsFor: 'accessing' stamp: ''!
runner: aRunner
	runner := aRunner.! !

!Benchmark methodsFor: 'benchmarking' stamp: ''!
selectedBenchmarks
	^ selectedBenchmarks! !

!Benchmark methodsFor: 'running' stamp: 'StefanMarr 6/30/2013 00:59'!
setUp
	"It is the subclass' responsibility to set up the necessary environment for a benchmark"
	^ self! !

!Benchmark methodsFor: 'testing' stamp: 'StefanMarr 6/30/2013 00:59'!
shouldRunSelector: selector
	"Tells whether the given selector is in the form bench*, and thus is a benchmark that should be executed."
	
	(selector includes: $:) ifTrue: [ ^ false ].
	^ selector beginsWith: #bench! !

!Benchmark methodsFor: 'running' stamp: 'StefanMarr 6/30/2013 00:58'!
tearDown
	"It is the subclass' responsibility to clean up the environment after a benchmark"
	^ self! !

Benchmark subclass: #BenchmarkTestBenchmark
	instanceVariableNames: 'a b c d'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark-Tests'!

!BenchmarkTestBenchmark commentStamp: 'StefanMarr 3/12/2011 22:13' prior: 0!
This class is used for unit testing only.!

!BenchmarkTestBenchmark class methodsFor: 'as yet unclassified' stamp: 'tfel 5/15/2015 10:58'!
defaultRunner
	^ BenchmarkTestSuite! !

!BenchmarkTestBenchmark class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/13/2011 20:57'!
isAbstractClass
	"This is more like a hack, but we do not want to execute this as a benchmark"
	^ true! !

!BenchmarkTestBenchmark methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/12/2011 22:15'!
a
	^a! !

!BenchmarkTestBenchmark methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/12/2011 22:15'!
b
	^b! !

!BenchmarkTestBenchmark methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/19/2011 00:35'!
benchA
	a := #executed.
	(Delay forMilliseconds: 1) wait.! !

!BenchmarkTestBenchmark methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/19/2011 00:38'!
benchB
	b := #executed.
	(Delay forMilliseconds: 1) wait.! !

!BenchmarkTestBenchmark methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/12/2011 22:37'!
benchC
	c := #executed.! !

!BenchmarkTestBenchmark methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/19/2011 01:04'!
benchWithMultipleCriteria
	| t1 t2 t3 |
	t3 := runner createTimer: 't3'.
	t3 start.
	
	(Delay forMilliseconds: 25) wait.
	
	t2:= runner createTimer: 't2'.
	t2 start.
	(Delay forMilliseconds: 15) wait.	
	
	t1 := runner createTimer: 't1'.  
	t1 start.
	(Delay forMilliseconds: 10) wait.
	
	
	t3 stop.
	t2 stop.
	t1 stop.    ! !

!BenchmarkTestBenchmark methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/12/2011 22:15'!
c
	^c! !

!BenchmarkTestBenchmark methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/12/2011 22:15'!
d
	^d! !

!BenchmarkTestBenchmark methodsFor: 'initialize-release' stamp: 'StefanMarr 3/18/2011 19:50'!
initialize
	super initialize.
	
	"Filling in some test data"
	a := 1.
	b := 2.
	c := #three.
	d := '42'.
	! !

!BenchmarkTestBenchmark methodsFor: 'running' stamp: 'StefanMarr 3/12/2011 22:39'!
setUp
	runner countSetUpInvoke! !

!BenchmarkTestBenchmark methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/13/2011 20:29'!
setUpBenchB
	runner didSetUpBenchB! !

!BenchmarkTestBenchmark methodsFor: 'running' stamp: 'StefanMarr 3/12/2011 22:39'!
tearDown
	runner countTearDownInvoke! !

!BenchmarkTestBenchmark methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/13/2011 20:30'!
tearDownBenchC
	runner didTearDownBenchC! !

BenchmarkTestBenchmark subclass: #BenchmarkTestBenchmarkWithBaseBenchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark-Tests'!

!BenchmarkTestBenchmarkWithBaseBenchmark methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/18/2011 18:32'!
baseBenchmark
	runner didRunBaseBenchmark.! !

Benchmark subclass: #BenchmarkTestSuiteBenchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark-Tests'!

!BenchmarkTestSuiteBenchmark commentStamp: 'StefanMarr 3/13/2011 22:58' prior: 0!
This is a benchmark suite used to test the benchmark runner!

!BenchmarkTestSuiteBenchmark class methodsFor: 'as yet unclassified' stamp: ''!
isAbstractClass
	"This is more like a hack, but we do not want to execute this as a benchmark"
	^ true! !

!BenchmarkTestSuiteBenchmark methodsFor: 'as yet unclassified' stamp: ''!
benchDoNothing
	"Just a dummy that should be executed and result in some measured value"
	^ self! !

!BenchmarkTestSuiteBenchmark methodsFor: 'as yet unclassified' stamp: ''!
benchNotifyRunner
	runner notifyRunnerWasExecuted.
	^ self! !

Benchmark subclass: #BenchmarkTestSuiteBenchmarkForAutosizing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark-Tests'!

!BenchmarkTestSuiteBenchmarkForAutosizing class methodsFor: 'as yet unclassified' stamp: 'tfel 5/15/2015 10:57'!
defaultRunner
	^ BenchmarkTestSuite! !

!BenchmarkTestSuiteBenchmarkForAutosizing methodsFor: 'as yet unclassified' stamp: ''!
baseBenchmark
	(Delay forMilliseconds: 5) wait.! !

!BenchmarkTestSuiteBenchmarkForAutosizing methodsFor: 'as yet unclassified' stamp: ''!
benchBig
	(Delay forMilliseconds: 100) wait.! !

!BenchmarkTestSuiteBenchmarkForAutosizing methodsFor: 'as yet unclassified' stamp: ''!
benchSmall
	(Delay forMilliseconds: 5) wait.! !

Benchmark subclass: #BenchmarkTestSuiteBenchmarkForPerfromBenchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark-Tests'!

!BenchmarkTestSuiteBenchmarkForPerfromBenchmark class methodsFor: 'as yet unclassified' stamp: 'tfel 5/15/2015 10:57'!
defaultRunner
	^ BenchmarkTestSuite! !

!BenchmarkTestSuiteBenchmarkForPerfromBenchmark methodsFor: 'as yet unclassified' stamp: ''!
BenchShouldNotBeExecuted
	"This one should not be executed"
	(Delay forMilliseconds: 5) wait.
	runner didPerform: #BenchShouldNotBeExecuted.! !

!BenchmarkTestSuiteBenchmarkForPerfromBenchmark methodsFor: 'as yet unclassified' stamp: ''!
baseBenchmark
	(Delay forMilliseconds: 5) wait.
	runner didPerform: #baseBenchmark.! !

!BenchmarkTestSuiteBenchmarkForPerfromBenchmark methodsFor: 'as yet unclassified' stamp: ''!
benchAfsdfsdfsdf
	(Delay forMilliseconds: 5) wait.
	runner didPerform: #benchAfsdfsdfsdf.! !

!BenchmarkTestSuiteBenchmarkForPerfromBenchmark methodsFor: 'as yet unclassified' stamp: ''!
benchBsdfasereSDSfsdfsdfs
	(Delay forMilliseconds: 5) wait.
	runner didPerform: #benchBsdfasereSDSfsdfsdfs.! !

!BenchmarkTestSuiteBenchmarkForPerfromBenchmark methodsFor: 'as yet unclassified' stamp: ''!
benchC
	(Delay forMilliseconds: 5) wait.
	runner didPerform: #benchC.! !

!BenchmarkTestSuiteBenchmarkForPerfromBenchmark methodsFor: 'as yet unclassified' stamp: ''!
benchZZ
	(Delay forMilliseconds: 5) wait.
	runner didPerform: #benchZZ.! !

Object subclass: #BenchmarkArgumentParser
	instanceVariableNames: 'runner reporter suiteOrBenchmark iterations processes problemSize i current numParams currentObj arguments suite specificBenchmark suiteClass harness'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark'!

!BenchmarkArgumentParser methodsFor: 'argument parsing' stamp: 'sm 5/25/2011 17:38'!
determineBenchmarkParameters
	"Initialize with defaults, will be overwritten in case
	 it is specified."
	iterations := runner class defaultNumberOfIterations.
	processes  := runner class defaultNumberOfProcesses.
	problemSize:= suiteClass defaultProblemSize.
	
	self determineBenchmarkParametersFromArguments.! !

!BenchmarkArgumentParser methodsFor: 'argument parsing' stamp: ''!
determineBenchmarkParametersFromArguments
	i := i + 1.
	i <= numParams ifTrue: [
		iterations := (arguments at: i) asInteger.
		i := i + 1.
		i <= numParams ifTrue: [
			processes := (arguments at: i) asInteger.
			i := i + 1.
			i <= numParams ifTrue: [
				problemSize := arguments at: i.
			]
		]
	].! !

!BenchmarkArgumentParser methodsFor: 'argument parsing' stamp: 'tfel 5/15/2015 10:18'!
determineReporter
	(currentObj isKindOf: BenchmarkReporter)
		ifFalse: [ reporter := harness defaultReporter new. ]
		ifTrue:  [ reporter := currentObj.
			i := i + 1.
			i <= numParams ifTrue: [
				current := arguments at: i.
			]
		].! !

!BenchmarkArgumentParser methodsFor: 'argument parsing' stamp: 'tfel 5/15/2015 10:49'!
determineRunner
	(currentObj isKindOf: BenchmarkSuite)
		ifFalse: [ runner := harness new. ]
		ifTrue:  [ runner := currentObj.
			i := i + 1.
			i <= numParams ifTrue: [
				current := arguments at: i.
				currentObj := (Smalltalk classNamed: current) ifNotNilDo: [:cls | cls new].
			]
		].! !

!BenchmarkArgumentParser methodsFor: 'argument parsing' stamp: 'sm 5/25/2011 17:26'!
determineSuiteOrBenchmark
	self parseBenchmarkOrSuite: current.! !

!BenchmarkArgumentParser methodsFor: 'accessing' stamp: ''!
harness: aHarness
	harness := aHarness! !

!BenchmarkArgumentParser methodsFor: 'helper' stamp: 'sm 5/25/2011 17:29'!
instructRunner
	suite := suiteClass new.
	specificBenchmark ifNotNil: [
		suite runOnly: specificBenchmark.
	].
	
	runner suite: suite.
 	runner iterations: iterations.
	runner processes: processes.
	runner problemSize: problemSize.! !

!BenchmarkArgumentParser methodsFor: 'parsing' stamp: 'tfel 5/15/2015 10:49'!
parse: argumentsArray
	arguments := argumentsArray.
	numParams := arguments size.
	
	i := 2.
	current := arguments at: i.
	currentObj := (Smalltalk classNamed: current) ifNotNilDo: [:cls | cls new].
		
	self determineRunner.
	self determineReporter.
	
	self determineSuiteOrBenchmark.
	
	self determineBenchmarkParameters.
	
	self instructRunner.
	
	^ {runner. reporter}! !

!BenchmarkArgumentParser methodsFor: 'argument parsing' stamp: ''!
parseBenchmarkOrSuite: aBenchmarkOrSuite
	"Identify the benchmark suite or suite and benchmark method
	 that should be executed. The string should be of the format 'Class>>benchName' or 'Class.benchName' for shell/bash compatibility.
	 Accepts a string, class, or array.
	 Returns, a class, or an array of a class and a symbol."
	| parsed |
	(aBenchmarkOrSuite isKindOf: Class)
		ifTrue: [
			suiteClass := aBenchmarkOrSuite.
			^ suiteClass
		].
	  
	(aBenchmarkOrSuite isKindOf: Array)
		ifTrue:  [ parsed := aBenchmarkOrSuite. ]
		ifFalse: [ parsed := aBenchmarkOrSuite findTokens: '>.'. ].
	
	((parsed size > 2) or: [parsed size < 1])
				ifTrue: [ Error signal: 'The passed argument has to represent two elements. A class/classname and a method symbol' ].
	
	suiteClass := parsed first.
	
	(suiteClass isKindOf: Class) 
		ifFalse: [ suiteClass := Smalltalk at: (suiteClass asSymbol) ifAbsent: [Error signal: 'Class that was supposed to represent a benchmark suite was not found: ', suiteClass asString ]].
	
	parsed size = 1
		ifTrue: [^suiteClass].

	specificBenchmark := parsed second asSymbol.
	
	^ { suiteClass. specificBenchmark }
! !

BenchmarkArgumentParser subclass: #BenchmarkWeakScalingArgumentParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark'!

!BenchmarkWeakScalingArgumentParser methodsFor: 'argument parsing' stamp: 'sm 5/25/2011 17:17'!
determineBenchmarkParametersFromArguments
	i := i + 1.
	i <= numParams ifTrue: [
		processes := (arguments at: i) asInteger.
		i := i + 1.
		i <= numParams ifTrue: [
			iterations := (arguments at: i) asInteger.
			i := i + 1.
			i <= numParams ifTrue: [
				problemSize := arguments at: i.
			]
		]
	].! !

!BenchmarkWeakScalingArgumentParser methodsFor: 'argument parsing' stamp: ''!
determineReporter
	reporter := harness defaultReporter new.! !

!BenchmarkWeakScalingArgumentParser methodsFor: 'argument parsing' stamp: ''!
determineRunner
	runner := harness defaultRunner new.! !

!BenchmarkWeakScalingArgumentParser methodsFor: 'helper' stamp: 'sm 5/25/2011 17:31'!
instructRunner
	super instructRunner.
	
	runner iterations: runner class defaultNumberOfIterations.
	runner innerIterations: iterations.! !

Object subclass: #BenchmarkConsole
	instanceVariableNames: ''
	classVariableNames: 'IsRVM LastPrintedChar OutputToTranscript Position PrintTarget'
	poolDictionaries: ''
	category: 'Benchmark-GUI'!

!BenchmarkConsole class methodsFor: 'streaming' stamp: 'tfel 5/12/2015 10:06'!
<< aString
	self print: aString! !

!BenchmarkConsole class methodsFor: 'printing' stamp: 'tfel 5/12/2015 10:06'!
cr
	self println: ''.! !

!BenchmarkConsole class methodsFor: 'initialization' stamp: 'tfel 5/15/2015 09:25'!
detectAvailableMechanismForStdout
	"The prefered means is to use the stdout file handle.
	 Will try to fall back on the RoarVM primitive if necessary."
	| cls |
	((FileStream respondsTo: #stdout) and: [[FileStream stdout nextPut: Character space. true] on: Error do: [false]])
		ifTrue: [
			PrintTarget := FileStream stdout.
			IsRVM := false. "Not needed when stdout is used"
			^ self.
		].
		
	cls := Smalltalk at: #RVMOperations ifAbsent: [nil].
	IsRVM := (cls notNil and: [cls perform: #isRVM]).
	IsRVM 
		ifTrue: [ 
			PrintTarget := cls.
			^ self.
		]
		ifFalse: [
			"Squeak 4.2 provides a stream at FileStream>>stdout"
			
		].
	
	PrintTarget := Transcript.
	^ Transcript! !

!BenchmarkConsole class methodsFor: 'as yet unclassified' stamp: 'tfel 5/12/2015 10:06'!
flush
	PrintTarget ifNotNil: [PrintTarget flush].! !

!BenchmarkConsole class methodsFor: 'initialization' stamp: 'tfel 5/15/2015 09:25'!
initialize
	"self initialize"
	OutputToTranscript := false.
	self detectAvailableMechanismForStdout.
	Position := 0.! !

!BenchmarkConsole class methodsFor: 'streaming' stamp: 'tfel 5/12/2015 10:06'!
nextPut: somethingAsString
	self print: somethingAsString! !

!BenchmarkConsole class methodsFor: 'streaming' stamp: 'tfel 5/12/2015 10:06'!
nextPutAll: somethingAsString
	self print: somethingAsString! !

!BenchmarkConsole class methodsFor: 'printing' stamp: 'tfel 5/12/2015 10:06'!
outputToTranscript
	^ OutputToTranscript! !

!BenchmarkConsole class methodsFor: 'printing' stamp: 'tfel 5/12/2015 10:06'!
outputToTranscript: aBool
	OutputToTranscript := aBool! !

!BenchmarkConsole class methodsFor: 'read, write, position' stamp: 'tfel 5/12/2015 10:06'!
peekLast
	^ LastPrintedChar! !

!BenchmarkConsole class methodsFor: 'read, write, position' stamp: 'tfel 5/12/2015 10:06'!
position
	^ Position! !

!BenchmarkConsole class methodsFor: 'printing' stamp: 'tfel 5/12/2015 10:06'!
print: somethingAsString
	self print: somethingAsString withLineEnding: ''.! !

!BenchmarkConsole class methodsFor: 'printing' stamp: 'tfel 5/15/2015 10:03'!
print: somethingAsString withLineEnding: lineEnd
	"Will output the somethingAsString to stdout using one of the available mechansims and to the transcript if requested"
	| output |
	output := somethingAsString asString.
	Position := Position + output size.
	output size > 0 ifTrue: [
		LastPrintedChar := output last].
	
	PrintTarget ifNotNil: [
		IsRVM ifTrue: [ PrintTarget print: output. ]
			   ifFalse: [ PrintTarget nextPutAll: (output, lineEnd) ].
	].

	(OutputToTranscript or: [PrintTarget isNil])
		ifTrue: [
			Transcript show: output, lineEnd.
		].! !

!BenchmarkConsole class methodsFor: 'printing' stamp: 'tfel 5/12/2015 10:06'!
println: somethingAsString
	self print: somethingAsString withLineEnding: String crlf.! !

!BenchmarkConsole class methodsFor: 'printing' stamp: 'tfel 5/12/2015 10:06'!
space
	"Append a space character to the receiver."

	self nextPut: Character space! !

!BenchmarkConsole class methodsFor: 'printing' stamp: 'tfel 5/12/2015 10:06'!
tab
	"Append a tab character to the receiver."

	self nextPut: Character tab! !

Object subclass: #BenchmarkReporter
	instanceVariableNames: 'runner stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark'!

!BenchmarkReporter commentStamp: '<historical>' prior: 0!
SMarkReporter is a simple formatter of benchmark results. 

Subclass such as SMarkSimpleStatisticsReporter might implement more advanced reporting functionality, e.g., including a statistical evaluation of the results.

Example:

	| f |
	f := TextStream on: String new.
	SMarkSimpleStatisticsReporter reportFor: (SMarkTestRunnerSuiteForAutosizing run: 10) on: f.
	f contents!

!BenchmarkReporter class methodsFor: 'defaults' stamp: 'tfel 6/2/2015 11:40'!
defaultOutputDestination
	^ BenchmarkConsole initialize; yourself! !

!BenchmarkReporter class methodsFor: 'defaults' stamp: 'tfel 5/15/2015 10:18'!
defaultReporter
	^ BenchmarkSimpleStatisticsReporter! !

!BenchmarkReporter class methodsFor: 'reporting' stamp: 'DamienPollet 1/15/2015 18:22'!
reportFor: aRunner
	^ self
		reportFor: aRunner
		on: self defaultOutputDestination.! !

!BenchmarkReporter class methodsFor: 'reporting' stamp: 'DamienPollet 1/15/2015 18:52'!
reportFor: aRunner on: aStream
	| reporter |
	reporter := self new
		runner: aRunner;
		outputStream: aStream;
		report; yourself.
	^ reporter.! !

!BenchmarkReporter methodsFor: 'reporting' stamp: ''!
benchmarkFooter: aName
	stream cr.! !

!BenchmarkReporter methodsFor: 'reporting' stamp: ''!
benchmarkHeader: aName
	stream << 'Benchmark ' << (aName asString); cr.! !

!BenchmarkReporter methodsFor: 'reporting' stamp: ''!
footer
	"No output at the moment"
	^ self! !

!BenchmarkReporter methodsFor: 'reporting' stamp: ''!
header
	| suiteName |
	suiteName := runner suite class name asString.
	stream << 'Report for: ' << suiteName; cr.! !

!BenchmarkReporter methodsFor: 'initialization' stamp: 'StephaneDucasse 6/16/2013 21:10'!
initialize
	super initialize.
	stream := self class defaultOutputDestination.! !

!BenchmarkReporter methodsFor: 'accessing' stamp: ''!
outputStream: aStream
	stream := aStream  ! !

!BenchmarkReporter methodsFor: 'accessing' stamp: ''!
report
	self header.
	
	runner results keysAndValuesDo: [:key :value |
		self benchmarkHeader: key.
		self reportAllRuns: value of: key.
		self benchmarkFooter: key.
	].

	self footer.
	^ self! !

!BenchmarkReporter methodsFor: 'reporting' stamp: 'CamilloBruni 9/5/2011 13:13'!
reportAllRuns: aListOfResults of: benchmark
	aListOfResults do: [:result |
		result criteria keysAndValuesDo: [:benchName :timer |
			stream << benchName << ': ' << (timer totalTime asString, 'ms'); cr.]]! !

!BenchmarkReporter methodsFor: 'accessing' stamp: 'tfel 5/11/2015 18:52'!
reportOn: aStream
	| oldStream |
	oldStream := stream.
	[stream := aStream.
	self header.
	runner results keysAndValuesDo: [:key :value |
		self benchmarkHeader: key.
		self reportAllRuns: value of: key.
		self benchmarkFooter: key].
	self footer] ensure: [stream := oldStream].! !

!BenchmarkReporter methodsFor: 'accessing' stamp: 'tfel 5/11/2015 19:35'!
runner

	^ runner! !

!BenchmarkReporter methodsFor: 'accessing' stamp: ''!
runner: aRunner
	runner := aRunner.! !

!BenchmarkReporter methodsFor: 'accessing' stamp: 'tfel 5/11/2015 19:36'!
suite

	^ runner suite! !

BenchmarkReporter subclass: #BenchmarkSimpleStatisticsReporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark'!

!BenchmarkSimpleStatisticsReporter methodsFor: 'statistics' stamp: 'tfel 5/11/2015 20:20'!
confidenceVariance: times
	| numMeasurements |
	numMeasurements := times size.
	(numMeasurements >= 30) 
		ifTrue: [
			^ (self gaussianConfidenceFactor) * (self stdev: times) / (numMeasurements asFloat sqrt)].
		
	"use the students T distribution for small probe counts"
	^ (self studentsTConfidenceFactorFor: numMeasurements) * (self stdev: times) / (numMeasurements asFloat sqrt)! !

!BenchmarkSimpleStatisticsReporter methodsFor: 'statistics' stamp: 'StefanMarr 3/20/2011 11:49'!
gaussianConfidenceFactor
	"used for large probe counts >= 30"
	"1 ~ 68.27%"
	"1.644853626951 ~ 90%"
	"2 ~ 95.45%"
	^ 1.644853626951! !

!BenchmarkSimpleStatisticsReporter methodsFor: 'reporting' stamp: 'StefanMarr 5/16/2011 16:08'!
reportAllRuns: aListOfResults of: benchmark
	| criteria |

	criteria := aListOfResults first criteria.
	
	criteria keysDo: [:criterion |
		| times |
		times := self resultsFor: criterion from: aListOfResults.
		self reportResult: times for: criterion of: benchmark.
		stream cr.
	].! !

!BenchmarkSimpleStatisticsReporter methodsFor: 'reporting' stamp: 'CamilloBruni 9/6/2011 10:41'!
reportResult: aResultsArray for: aCriterion of: benchmark
	| convidenceVariance significantDigits |

	stream << benchmark <<  ' ' <<  aCriterion <<  ': iterations='.
	aResultsArray size printOn: stream .
	stream << ' runtime: '.
	
	aResultsArray size < 2 ifTrue: [
		aResultsArray average printOn: stream.
		stream << 'ms'.
		^ self.
	].
	
	convidenceVariance := self confidenceVariance: aResultsArray.  
	
	"only print significant "
	significantDigits := self significantDigits: convidenceVariance.

	aResultsArray average printOn: stream showingDecimalPlaces: significantDigits.
	stream << 'ms +/-'.
	convidenceVariance printOn: stream showingDecimalPlaces: significantDigits.! !

!BenchmarkSimpleStatisticsReporter methodsFor: 'helper' stamp: 'StefanMarr 5/16/2011 16:02'!
resultsFor: aCriterion from: aListOfResults
	^aListOfResults collect: [:result | (result criteria at: aCriterion) totalTime]
	! !

!BenchmarkSimpleStatisticsReporter methodsFor: 'statistics' stamp: 'StefanMarr 3/20/2011 11:46'!
significantDigits: confidenceVariance
	confidenceVariance = 0 
		ifTrue: [ ^ 2].
	
	confidenceVariance >= 10
		ifTrue: [ ^ 0].
	
	^ 1 - (confidenceVariance log floor)! !

!BenchmarkSimpleStatisticsReporter methodsFor: 'statistics' stamp: 'tfel 5/11/2015 20:25'!
stdev: aCollection
	| m |
	m := aCollection median.
	^ ((aCollection inject: 0 into: [:acc :each | acc + (each - m) squared]) / aCollection size) sqrt! !

!BenchmarkSimpleStatisticsReporter methodsFor: 'statistics' stamp: 'StefanMarr 3/20/2011 12:03'!
studentsTConfidenceFactorFor: aNumberOfMeasurements
	"used for small probe counts < 30"
	"the students T distribution sucks to calculate since the value depends on the probeCout"
	"these values are for a confidence interval of ~90%"
	| values |
	values := Array new: 30.
	values at: 1  put: 6.314.
	values at: 2  put: 2.920.
	values at: 3  put: 2.353.
	values at: 4  put: 2.132.
	values at: 5  put: 2.015.
	values at: 6  put: 1.943.
	values at: 7  put: 1.895.
	values at: 8  put: 1.860.
	values at: 9  put: 1.833.
	values at: 10 put: 1.812.
	values at: 11 put: 1.796.
	values at: 12 put: 1.782.
	values at: 13 put: 1.771.
	values at: 14 put: 1.761.
	values at: 15 put: 1.753.
	values at: 16 put: 1.746.
	values at: 17 put: 1.740.
	values at: 18 put: 1.734.
	values at: 19 put: 1.729.
	values at: 20 put: 1.725.
	values at: 21 put: 1.721.
	values at: 22 put: 1.717.
	values at: 23 put: 1.714.
	values at: 24 put: 1.711.
	values at: 25 put: 1.708.
	values at: 26 put: 1.706.
	values at: 27 put: 1.703.
	values at: 28 put: 1.701.
	values at: 29 put: 1.699.
	values at: 30 put: 1.697.
	^ values at: aNumberOfMeasurements.
	! !

!BenchmarkSimpleStatisticsReporter methodsFor: 'helper' stamp: 'DamienPollet 1/15/2015 18:30'!
totalResultsFor: aListOfResults
	^ aListOfResults collect: [:result | result total]
	! !

BenchmarkSimpleStatisticsReporter subclass: #BenchmarkWeakScalingReporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark'!

!BenchmarkWeakScalingReporter commentStamp: '<historical>' prior: 0!
A ReBenchReporter is reporter for the ReBench framework (cf. https://github.com/smarr/ReBench).
It is used be the ReBenchHarness, which is the main class of interest for users that just want to execute benchmarks.!

!BenchmarkWeakScalingReporter methodsFor: 'as yet unclassified' stamp: 'StefanMarr 5/16/2011 15:23'!
benchmarkHeader: aName
	^ self! !

Object subclass: #BenchmarkResult
	instanceVariableNames: 'time incGCtime fullGCtime benchName suite criteria'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark'!

!BenchmarkResult commentStamp: 'StefanMarr 3/18/2011 23:45' prior: 0!
A benchmark result is characterized by:
 - the total execution time (#total is the least a benchmark results in)
 - the name of the benchmark that was executed
 - the suite object specifies the used input used for the benchmark
 - dictionary of additional the criteria and the related timings

A benchmark can produced multiple resuts for different criteria. The standard criterion is #total.!

!BenchmarkResult methodsFor: 'accessing' stamp: ''!
benchmarkName
	^ benchName! !

!BenchmarkResult methodsFor: 'accessing' stamp: ''!
benchmarkName: aString
	benchName := aString! !

!BenchmarkResult methodsFor: 'accessing' stamp: ''!
criteria
	^ criteria! !

!BenchmarkResult methodsFor: 'accessing' stamp: ''!
criteria: aCollectionOfTimers
	criteria := aCollectionOfTimers! !

!BenchmarkResult methodsFor: 'accessing' stamp: 'tfel 4/21/2016 14:21'!
fullGCtotal
	^ fullGCtime! !

!BenchmarkResult methodsFor: 'accessing' stamp: 'tfel 4/21/2016 14:21'!
fullGCtotal: aNumber
	fullGCtime := aNumber! !

!BenchmarkResult methodsFor: 'accessing' stamp: 'tfel 4/21/2016 14:21'!
incGCtotal
	^ incGCtime! !

!BenchmarkResult methodsFor: 'accessing' stamp: 'tfel 4/21/2016 14:21'!
incGCtotal: aNumber
	incGCtime := aNumber! !

!BenchmarkResult methodsFor: 'accessing' stamp: ''!
suite
	^ suite! !

!BenchmarkResult methodsFor: 'accessing' stamp: ''!
suite: aBenchmarkSuite
	suite := aBenchmarkSuite! !

!BenchmarkResult methodsFor: 'accessing' stamp: 'tfel 4/21/2016 14:05'!
timer

	^ self criteria at: #total! !

!BenchmarkResult methodsFor: 'accessing' stamp: ''!
total
	^ time! !

!BenchmarkResult methodsFor: 'accessing' stamp: ''!
total: aTime
	time := aTime! !

Object subclass: #BenchmarkRunner
	instanceVariableNames: 'categories categoriesSelected classes classIndex classesSelected resultList resultSelected failedList failedSelected errorList errorSelected lastUpdate categoryPattern classPattern numIterations doWarmup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark-GUI'!

!BenchmarkRunner commentStamp: '<historical>' prior: 0!
<lint: #ignore rule: #classNotReferenced rational: 'this view is only accessed from menus'>

!

!BenchmarkRunner class methodsFor: 'instance-creation' stamp: 'tfel 5/11/2015 17:45'!
build
	^ ToolBuilder build: self new.! !

!BenchmarkRunner class methodsFor: 'initialization' stamp: 'tfel 5/11/2015 17:45'!
initialize
	self registerInWorldMenu; registerInToolsFlap.! !

!BenchmarkRunner class methodsFor: 'instance-creation' stamp: 'tfel 5/11/2015 17:45'!
open
	^ ToolBuilder open: self new.! !

!BenchmarkRunner class methodsFor: 'initialization' stamp: 'tfel 5/11/2015 17:46'!
registerInToolsFlap
	self environment at: #Flaps ifPresent: [ :class |
		class
			registerQuad: #( TestRunner build 'SMark Runner' 'A benchmark-runner.' ) forFlapNamed: 'Tools';
			replaceToolsFlap ].! !

!BenchmarkRunner class methodsFor: 'initialization' stamp: 'tfel 5/11/2015 17:46'!
registerInWorldMenu
	self environment at: #TheWorldMenu ifPresent: [ :class |
		class registerOpenCommand: (Array 
			with: 'Benchmark Runner' 
			with: (Array
				with: self
				with: #open)) ].! !

!BenchmarkRunner class methodsFor: 'window color' stamp: 'tfel 5/11/2015 17:46'!
windowColorSpecification

	^ WindowColorSpec 
		classSymbol: self name 
		wording: 'Benchmark Runner' 
		brightColor:  Color orange
		pastelColor: (Color r: 0.65 g: 0.753 b: 0.976)
		helpMessage: 'The BenchmarkRunner tool for SMark'! !

!BenchmarkRunner methodsFor: 'actions' stamp: 'tfel 4/19/2016 12:20'!
askQuestions

	| iterations |
	iterations := #(1 5 10),
					(20 to: 100 by: 10),
					(200 to: 1000 by: 100),
					(2000 to: 10000 by: 1000).
	numIterations := (UIManager default chooseFrom: iterations values: iterations title: 'How many iterations?').
	numIterations ifNil: [^ false].
	doWarmup := (UIManager default chooseFrom: #(Yes No) values: #(true false) title: 'Should we do a warmup run?').
	doWarmup ifNil: [^ false].
	^ true! !

!BenchmarkRunner methodsFor: 'accessing' stamp: 'tfel 5/15/2015 10:46'!
baseClass

	^ Benchmark! !

!BenchmarkRunner methodsFor: 'actions' stamp: 'tfel 5/11/2015 18:23'!
basicRunSuite: aTestSuite
	aTestSuite do: [:cls |
		cls benchmarkSelectors
			do: [:each | self runBenchmark: each inSuite: cls]
			displayingProgress: [ :test | cls name, '>>', test printString ]
			every: 0 "Update the label for all tests"
	].! !

!BenchmarkRunner methodsFor: 'accessing-classes' stamp: 'tfel 5/11/2015 17:45'!
browseClass
	(classes at: classIndex ifAbsent: [ ^ self ]) browse! !

!BenchmarkRunner methodsFor: 'private' stamp: 'tfel 5/11/2015 17:45'!
browserEnvironment
	^ Smalltalk classNamed: #BrowserEnvironment.! !

!BenchmarkRunner methodsFor: 'building' stamp: 'tfel 5/11/2015 17:45'!
buildButtonsWith: aBuilder
	^ aBuilder pluggablePanelSpec new
		model: self;
		layout: #horizontal;
		children: (self buttons collect: [ :each |
			aBuilder pluggableButtonSpec new
				model: self; 
				label: each first;
				action: each second;
				enabled: each third;
				yourself ]);
		yourself.! !

!BenchmarkRunner methodsFor: 'building' stamp: 'tfel 5/11/2015 17:45'!
buildCategoriesWith: aBuilder
	^ aBuilder pluggableMultiSelectionListSpec new
		model: self;
		list: #categoryList;
		menu: #categoryMenu:;
		getIndex: #categorySelected;
		setIndex: #categorySelected:;
		getSelectionList: #categoryAt:;
		setSelectionList: #categoryAt:put:;
		yourself.! !

!BenchmarkRunner methodsFor: 'building' stamp: 'tfel 5/11/2015 17:45'!
buildClassesWith: aBuilder
	^ aBuilder pluggableMultiSelectionListSpec new
		model: self;
		list: #classList;
		menu: #classMenu:;
		getIndex: #classSelected;
		setIndex: #classSelected:;
		getSelectionList: #classAt:;
		setSelectionList: #classAt:put:;
		yourself.! !

!BenchmarkRunner methodsFor: 'building' stamp: 'tfel 5/11/2015 17:45'!
buildErrorListWith: aBuilder
	^ aBuilder pluggableListSpec new
		model: self;
		name: 'Error List';
		list: #errorList; 
		menu: #errorMenu:;
		getIndex: #errorSelected; 
		setIndex: #errorSelected:;
		yourself.! !

!BenchmarkRunner methodsFor: 'building' stamp: 'tfel 5/11/2015 17:45'!
buildFailureListWith: aBuilder
	^ aBuilder pluggableListSpec new
		model: self;
		name: 'Failure List';
		list: #failedList; 
		menu: #failureMenu:;
		getIndex: #failedSelected; 
		setIndex: #failedSelected:;
		yourself.! !

!BenchmarkRunner methodsFor: 'building' stamp: 'tfel 5/11/2015 17:52'!
buildResultListWith: aBuilder
	^ aBuilder pluggableListSpec new
		model: self;
		name: 'Result List';
		list: #resultList; 
		menu: #resultMenu:;
		getIndex: #resultSelected; 
		setIndex: #resultSelected:;
		yourself.! !

!BenchmarkRunner methodsFor: 'building' stamp: 'tfel 5/11/2015 17:45'!
buildStatusWith: aBuilder
	^ aBuilder pluggableInputFieldSpec new
		model: self;
		menu: #statusMenu:;
		color: #statusColor;
		getText: #statusText;
		yourself.! !

!BenchmarkRunner methodsFor: 'building' stamp: 'tfel 5/11/2015 17:51'!
buildWith: aBuilder
	| window |
	window := aBuilder pluggableWindowSpec new
		model: self; label: self label; extent: self extent;
		children: (OrderedCollection new 
			add: ((self buildCategoriesWith: aBuilder)
				frame: self categoriesFrame;
				yourself);
			add: ((self buildClassesWith: aBuilder)
				frame: self classesFrame;
				yourself);
			add: ((self buildStatusWith: aBuilder)
				frame: self statusFrame;
				yourself);
			add: ((self buildResultListWith: aBuilder)
				frame: self resultListFrame;
				yourself);
			add: ((self buildFailureListWith: aBuilder)
				frame: self failureListFrame;
				yourself);
			add: ((self buildErrorListWith: aBuilder)
				frame: self errorListFrame;
				yourself);
			add: ((self buildButtonsWith: aBuilder)
				frame: self buttonsFrame;
				yourself);
			yourself);
		yourself.
	^ aBuilder build: window.! !

!BenchmarkRunner methodsFor: 'building' stamp: 'tfel 5/11/2015 17:45'!
buttonHeight
	^Preferences standardButtonFont height + 25! !

!BenchmarkRunner methodsFor: 'accessing-ui' stamp: 'tfel 5/11/2015 18:05'!
buttons
	^ #(( 'Run Selected' #runAll #hasRunnable )
		( 'Run Profiled' #runProfiled #hasRunnable )
		( 'Run Failures' #runFailures #hasFailures )
		( 'Run Errors' #runErrors #hasErrors ))! !

!BenchmarkRunner methodsFor: 'building' stamp: 'tfel 5/11/2015 17:45'!
buttonsFrame
	^LayoutFrame new
		leftFraction: 0 offset: 0;
		topFraction: 1 offset: self buttonHeight negated;
		rightFraction: 1 offset: 0;
		bottomFraction: 1 offset: 0! !

!BenchmarkRunner methodsFor: 'building' stamp: 'tfel 5/11/2015 17:45'!
categoriesFrame
	^LayoutFrame new
		leftFraction: 0 offset: 0;
		topFraction: 0 offset: 0;
		rightFraction: 0.25 offset: 0;
		bottomFraction: 1 offset: self buttonHeight negated + 4! !

!BenchmarkRunner methodsFor: 'accessing-categories' stamp: 'tfel 5/11/2015 17:45'!
categoryAt: anIndex
	^ categoriesSelected includes: (categories at: anIndex ifAbsent: [ ^ false ]).! !

!BenchmarkRunner methodsFor: 'accessing-categories' stamp: 'tfel 5/11/2015 17:45'!
categoryAt: anInteger put: aBoolean
	categoriesSelected := categoriesSelected
		perform: (aBoolean ifTrue: [ #copyWith: ] ifFalse: [ #copyWithout: ])
		with: (categories at: anInteger ifAbsent: [ ^ self ]).
	self changed: #categorySelected; updateClasses.! !

!BenchmarkRunner methodsFor: 'accessing-categories' stamp: 'tfel 5/11/2015 17:45'!
categoryList
	^ categories! !

!BenchmarkRunner methodsFor: 'accessing-categories' stamp: 'tfel 5/11/2015 17:45'!
categoryMenu: aMenu
	^ aMenu
		title: 'Categories';
		add: 'Select all' action: #selectAllCategories;
		add: 'Select inversion' action: #selectInverseCategories;
		add: 'Select none' action: #selectNoCategories;
		addLine;
		add: 'Filter...' action: #filterCategories;
		addLine;
		add: 'Refresh' action: #updateCategories;
		yourself.! !

!BenchmarkRunner methodsFor: 'accessing-categories' stamp: 'tfel 5/11/2015 17:45'!
categorySelected
	^ 0! !

!BenchmarkRunner methodsFor: 'accessing-categories' stamp: 'tfel 5/11/2015 17:45'!
categorySelected: anInteger
	self changed: #categorySelected.! !

!BenchmarkRunner methodsFor: 'accessing-classes' stamp: 'tfel 5/11/2015 17:45'!
classAt: anInteger
	^ classesSelected includes: (classes at: anInteger ifAbsent: [ ^ false ]).! !

!BenchmarkRunner methodsFor: 'accessing-classes' stamp: 'tfel 5/11/2015 17:45'!
classAt: anInteger put: aBoolean
	classesSelected := classesSelected
		perform: (aBoolean ifTrue: [ #copyWith: ] ifFalse: [ #copyWithout: ])
		with: (classes at: anInteger ifAbsent: [ ^ self ]).
	self changed: #classSelected; changed: #hasRunnable.! !

!BenchmarkRunner methodsFor: 'accessing-classes' stamp: 'tfel 5/11/2015 18:04'!
classList
	| offset |
	classes isEmpty ifTrue: [ ^ classes ].
	offset := classes first allSuperclasses size.
	^ classes collect: [ :each | | ident |
		ident := String 
			new: 2 * (0 max: each allSuperclasses size - offset) 
			withAll: $ .
		(each isAbstract or: [each benchmarkSelectors size = 0])
			ifFalse: [ ident , each name ]
			ifTrue: [ 
				ident asText , each name asText 
					addAttribute: TextEmphasis italic;
					yourself ] ].! !

!BenchmarkRunner methodsFor: 'accessing-classes' stamp: 'tfel 5/11/2015 18:42'!
classMenu: aMenu
	
	aMenu
		title: 'Classes';
		add: 'Browse' action: #browseClass;
		addLine;
		add: 'Select all' action: #selectAllClasses;
		add: 'Select subclasses' action: #selectSubclasses;
		add: 'Select inversion' action: #selectInverseClasses;
		add: 'Select none' action: #selectNoClasses;
		addLine;
		add: 'Filter...' action: #filterClasses;
		addLine;
		add: 'Refresh' action: #updateClasses.
	self classSelected ~= 0 ifTrue: [
		aMenu addLine.
		(classes at: self classSelected) benchmarkSelectors do: [:ea |
			aMenu add: 'Run ', ea asString selector: #runSingleTest: argument: ea]].
	^ aMenu! !

!BenchmarkRunner methodsFor: 'accessing-classes' stamp: 'tfel 5/11/2015 17:45'!
classSelected
	^ classIndex! !

!BenchmarkRunner methodsFor: 'accessing-classes' stamp: 'tfel 5/11/2015 17:45'!
classSelected: anInteger
	classIndex := anInteger.
	self changed: #classSelected! !

!BenchmarkRunner methodsFor: 'building' stamp: 'tfel 5/11/2015 17:45'!
classesFrame
	^LayoutFrame new
		leftFraction: 0.25 offset: 0;
		topFraction: 0 offset: 0;
		rightFraction: 0.5 offset: 0;
		bottomFraction: 1 offset: self buttonHeight negated + 4! !

!BenchmarkRunner methodsFor: 'accessing' stamp: 'tfel 5/11/2015 17:45'!
classesSelected
	^ classesSelected! !

!BenchmarkRunner methodsFor: 'actions' stamp: 'tfel 5/11/2015 20:17'!
compareWithPrevious: aReport

	| history |
	history := aReport suite class historyAt: aReport runner selector.
	history size > 1 ifFalse: [^ self].
	1 halt.! !

!BenchmarkRunner methodsFor: 'actions' stamp: 'tfel 4/21/2016 16:39'!
debug: anItem

	(anItem isKindOf: BenchmarkReporter)
		ifTrue: [
			^ anItem runner results keysAndValuesDo: [:benchmark :results |
				(BenchmarkWarmupGraph
					forBenchmark: benchmark
					results: results) openInWorld]].
	(anItem isKindOf: Process)
		ifTrue: [anItem debugWithTitle: 'Debug benchmark'. self updateResults].! !

!BenchmarkRunner methodsFor: 'private' stamp: 'tfel 5/11/2015 18:24'!
defaultBackgroundColor
	"<lint: #expect rule: #overridesSuper rational: 'we want a different color than the parent'>"

	^ Preferences testRunnerWindowColor muchLighter! !

!BenchmarkRunner methodsFor: 'accessing-testing' stamp: 'tfel 5/11/2015 17:45'!
errorList
	^ errorList collect: [ :each | each printString ].! !

!BenchmarkRunner methodsFor: 'building' stamp: 'tfel 5/11/2015 17:53'!
errorListFrame
	^LayoutFrame new
		leftFraction: 0.5 offset: 0;
		topFraction: 0.7 offset: 0;
		rightFraction: 1 offset: 0;
		bottomFraction: 1 offset: self buttonHeight negated + 4! !

!BenchmarkRunner methodsFor: 'accessing-menu' stamp: 'tfel 5/11/2015 17:45'!
errorMenu: aMenu
	^ self statusMenu: aMenu! !

!BenchmarkRunner methodsFor: 'accessing-testing' stamp: 'tfel 5/11/2015 17:45'!
errorSelected
	^ errorList indexOf: errorSelected.! !

!BenchmarkRunner methodsFor: 'accessing-testing' stamp: 'tfel 4/21/2016 13:14'!
errorSelected: anInteger
	errorSelected := errorList at: anInteger ifAbsent: nil.
	self changed: #errorSelected.
	errorSelected ifNotNil: [
		self removeAt: anInteger.
		self debug: errorSelected]! !

!BenchmarkRunner methodsFor: 'accessing-ui' stamp: 'tfel 5/11/2015 17:45'!
extent
	^ 640 @ 480! !

!BenchmarkRunner methodsFor: 'accessing-testing' stamp: 'tfel 5/11/2015 17:45'!
failedList
	^ failedList collect: [ :each | each printString ].! !

!BenchmarkRunner methodsFor: 'accessing-testing' stamp: 'tfel 5/11/2015 17:45'!
failedSelected
	^ failedList indexOf: failedSelected.! !

!BenchmarkRunner methodsFor: 'accessing-testing' stamp: 'tfel 5/11/2015 17:45'!
failedSelected: anInteger
	failedSelected := failedList at: anInteger ifAbsent: nil.
	self changed: #failedSelected.
	failedSelected ifNotNil: [ self debug: failedSelected ].! !

!BenchmarkRunner methodsFor: 'building' stamp: 'tfel 5/11/2015 17:53'!
failureListFrame
	^LayoutFrame new
		leftFraction: 0.5 offset: 0;
		topFraction: 0.4 offset: 0;
		rightFraction: 1 offset: 0;
		bottomFraction: 0.7 offset: 0! !

!BenchmarkRunner methodsFor: 'accessing-menu' stamp: 'tfel 5/11/2015 17:45'!
failureMenu: aMenu
	^ aMenu! !

!BenchmarkRunner methodsFor: 'accessing-categories' stamp: 'tfel 5/11/2015 17:45'!
filterCategories
	| pattern |
	pattern := UIManager default 
					request: 'Pattern(s) to select categories:\    (separate patterns with '';'')' withCRs
					initialAnswer: (categoryPattern ifNil: ['*']).
	(pattern isNil or: [pattern isEmpty]) ifTrue:
		[^self].
	categoriesSelected := ((categoryPattern := pattern) subStrings: ';')
								inject: Set new
								into: [:matches :subPattern|
									matches
										addAll: (categories select: [ :each | subPattern match: each]);
										yourself].
	self changed: #allSelections; changed: #categorySelected; updateClasses! !

!BenchmarkRunner methodsFor: 'accessing-classes' stamp: 'tfel 5/11/2015 17:45'!
filterClasses
	| pattern |
	pattern := UIManager default 
					request: 'Pattern(s) to select tests:\  (separate patterns with '';'')' withCRs
					initialAnswer: (classPattern ifNil: '*').
	(pattern isNil or: [pattern isEmpty]) ifTrue:
		[^self].
	classesSelected := ((classPattern := pattern) subStrings: ';')
							inject: Set new
							into: [:matches :subPattern|
								matches
									addAll: (classes select: [ :each | subPattern match: each name]);
									yourself].
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!BenchmarkRunner methodsFor: 'utilities' stamp: 'tfel 5/11/2015 17:45'!
findCategories
	| visible |
	visible := Set new.
	self baseClass withAllSubclassesDo: [ :each |
		each category ifNotNil: [ :category |
			visible add: category ] ].
	^ Array streamContents: [ :stream |
		Smalltalk organization categories do: [ :each |
			(visible includes: each)
				ifTrue: [ stream nextPut: each ] ] ].! !

!BenchmarkRunner methodsFor: 'utilities' stamp: 'tfel 5/11/2015 17:45'!
findClassesForCategories: aCollection

	| items |
	aCollection isEmpty 
		ifTrue: [ ^ self baseClass withAllSubclasses asSet ].
	items := aCollection gather: [ :category |
		((Smalltalk organization listAtCategoryNamed: category)
			collect: [ :each | Smalltalk at: each ])
			select: [ :each | each includesBehavior: self baseClass ] ].
	^ items asSet.! !

!BenchmarkRunner methodsFor: 'testing' stamp: 'tfel 5/11/2015 18:24'!
hasErrors
	^ errorList notEmpty! !

!BenchmarkRunner methodsFor: 'testing' stamp: 'tfel 5/11/2015 18:24'!
hasFailures
	^ failedList notEmpty! !

!BenchmarkRunner methodsFor: 'testing' stamp: 'tfel 5/11/2015 18:24'!
hasRunnable
	^ classesSelected notEmpty! !

!BenchmarkRunner methodsFor: 'initialization' stamp: 'tfel 5/11/2015 18:41'!
initialize
	super initialize.
	self resetLists.
	SystemChangeNotifier uniqueInstance 
		notify: self ofSystemChangesOfItem: #class change: #Added using: #update;
		notify: self ofSystemChangesOfItem: #category change: #Added using: #update;
		notify: self ofSystemChangesOfItem: #class change: #Removed using: #update;
		notify: self ofSystemChangesOfItem: #category change: #Removed using: #update;
		notify: self ofSystemChangesOfItem: #class change: #Renamed using: #update;
		notify: self ofSystemChangesOfItem: #category change: #Renamed using: #update;
		notify: self ofSystemChangesOfItem: #class change: #Recategorized using: #update;
		notify: self ofSystemChangesOfItem: #category change: #Recategorized using: #update.
	self update; reset! !

!BenchmarkRunner methodsFor: 'accessing-ui' stamp: 'tfel 5/11/2015 18:05'!
label
	^ 'Benchmark Runner' ! !

!BenchmarkRunner methodsFor: 'accessing' stamp: 'tfel 5/11/2015 17:45'!
methodList
	self classesSelected ifEmpty: [ ^ #() ].
	^ self classesSelected gather: [:cls |
		cls benchmarkSelectors]! !

!BenchmarkRunner methodsFor: 'private' stamp: 'tfel 5/11/2015 17:45'!
perform: selector orSendTo: otherTarget
	"<lint: #expect rule: #badMessage rational: 'this is a common morphic pattern'>"
	
	^ (self respondsTo: selector)
		ifTrue: [ self perform: selector ]
		ifFalse: [ super perform: selector orSendTo: otherTarget ].! !

!BenchmarkRunner methodsFor: 'accessing-ui' stamp: 'tfel 5/11/2015 17:45'!
postAcceptBrowseFor: aModel
	"Nothing to do."! !

!BenchmarkRunner methodsFor: 'accessing-ui' stamp: 'tfel 5/11/2015 17:45'!
representsSameBrowseeAs: anotherModel 
	^ self class = anotherModel class
	and: [ classesSelected = anotherModel classesSelected ]! !

!BenchmarkRunner methodsFor: 'actions' stamp: 'tfel 5/11/2015 18:41'!
reset
	
	self
		resetLists;
		updateResults.! !

!BenchmarkRunner methodsFor: 'actions' stamp: 'tfel 5/11/2015 18:45'!
resetLists

	resultList := OrderedCollection new.
	failedList := OrderedCollection new.
	errorList := OrderedCollection new.! !

!BenchmarkRunner methodsFor: 'accessing-testing' stamp: 'tfel 5/11/2015 18:54'!
resultList
	^ resultList collect: [ :each | String streamContents: [:s | each reportOn: s]]! !

!BenchmarkRunner methodsFor: 'building' stamp: 'tfel 5/11/2015 17:54'!
resultListFrame
	^LayoutFrame new
		leftFraction: 0.5 offset: 0;
		topFraction: 0 offset: self statusHeight;
		rightFraction: 1 offset: 0;
		bottomFraction: 0.4 offset: 0! !

!BenchmarkRunner methodsFor: 'accessing-menu' stamp: 'tfel 5/11/2015 20:10'!
resultMenu: aMenu

	resultSelected ifNil: [
		^ aMenu addTitle: 'Select one of the results'].
	^ aMenu
		add: 'Compare with previous runs' selector: #compareWithPrevious: argument: resultSelected;
		yourself! !

!BenchmarkRunner methodsFor: 'accessing-testing' stamp: 'tfel 5/11/2015 17:55'!
resultSelected
	^ resultList indexOf: resultSelected.! !

!BenchmarkRunner methodsFor: 'accessing-testing' stamp: 'tfel 5/11/2015 17:55'!
resultSelected: anInteger
	resultSelected := resultList at: anInteger ifAbsent: nil.
	self changed: #resultSelected.
	resultSelected ifNotNil: [ self debug: resultSelected ].! !

!BenchmarkRunner methodsFor: 'actions' stamp: 'tfel 4/19/2016 12:20'!
runAll
	self askQuestions ifTrue: [
		self reset; runSuite: self classesSelected.
		self saveResultInHistory].! !

!BenchmarkRunner methodsFor: 'actions' stamp: 'tfel 4/21/2016 13:11'!
runBenchmark: aBenchmark inSuite: suite
	| reporter |
	(doWarmup ifTrue: [2] ifFalse: [1]) timesRepeat: [
	[reporter := BenchmarkAutosizeSuite
		run: suite
		specificBenchmark: aBenchmark
		iterations: numIterations
		processes: 1
		problemSize: 5
		reporter: BenchmarkSimpleStatisticsReporter]
			on: Error
			do: [:ex || p |
				p := Processor activeProcess.
				self assert: (Project current spawnNewProcessIfThisIsUI: p).
				errorList add: p.
				Project current addDeferredUIMessage: [
					reporter ifNotNil: [resultList add: reporter].
					self	
						updateStatus: true;
						updateResults].
				p suspend.]].
	reporter ifNotNil: [resultList add: reporter].
	self
		updateStatus: true;
		updateResults.! !

!BenchmarkRunner methodsFor: 'actions' stamp: 'tfel 5/11/2015 17:45'!
runErrors
	self result instVarNamed: 'errors' put: OrderedCollection new.
	self runSuite: self suiteErrors.! !

!BenchmarkRunner methodsFor: 'actions' stamp: 'tfel 5/11/2015 17:45'!
runFailures
	self result instVarNamed: 'failures' put: Set new.
	self runSuite: self suiteFailures.! !

!BenchmarkRunner methodsFor: 'actions' stamp: 'tfel 4/19/2016 12:20'!
runProfiled

	self askQuestions ifTrue: [
		self reset.
		MessageTally spyOn: [
			self runSuite: self classesSelected]].! !

!BenchmarkRunner methodsFor: 'actions' stamp: 'tfel 4/20/2016 09:11'!
runSingleTest: aSelector
	self askQuestions ifTrue: [| cls |
		self reset.
		cls := classes at: self classSelected.
		{aSelector}
			do: [:ea | self runBenchmark: aSelector inSuite: cls]
			displayingProgress: [:t | cls name, '>>', t printString]
			every: 0.
		self updateResults].! !

!BenchmarkRunner methodsFor: 'actions' stamp: 'tfel 4/21/2016 13:10'!
runSuite: aTestSuite

	self basicRunSuite: aTestSuite.
! !

!BenchmarkRunner methodsFor: 'history saving' stamp: 'tfel 5/11/2015 19:49'!
saveResultInHistory

	resultList do: [:r |
		r suite class historyAdd: r at: r runner selector].
! !

!BenchmarkRunner methodsFor: 'accessing-categories' stamp: 'tfel 5/11/2015 17:45'!
selectAllCategories
	categoriesSelected := categories asSet.
	self changed: #allSelections; changed: #categorySelected; updateClasses! !

!BenchmarkRunner methodsFor: 'accessing-classes' stamp: 'tfel 5/11/2015 17:45'!
selectAllClasses
	"Fixed to update all selections now that the
	selection invalidation has been optimised."
	
	classesSelected := classes asSet.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!BenchmarkRunner methodsFor: 'accessing-categories' stamp: 'tfel 5/11/2015 17:45'!
selectInverseCategories
	categoriesSelected := categories asSet 
		removeAll: categoriesSelected;
		yourself.
	self changed: #allSelections; changed: #categorySelected; updateClasses! !

!BenchmarkRunner methodsFor: 'accessing-classes' stamp: 'tfel 5/11/2015 17:45'!
selectInverseClasses
	"Fixed to update all selections now that the
	selection invalidation has been optimised."
	
	classesSelected := classes asSet 
		removeAll: classesSelected;
		yourself.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!BenchmarkRunner methodsFor: 'accessing-categories' stamp: 'tfel 5/11/2015 17:45'!
selectNoCategories
	categoriesSelected := Set new.
	self changed: #allSelections; changed: #categorySelected; updateClasses! !

!BenchmarkRunner methodsFor: 'accessing-classes' stamp: 'tfel 5/11/2015 17:45'!
selectNoClasses
	"Fixed to update all selections now that the
	selection invalidation has been optimised."
	
	classesSelected := Set new.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!BenchmarkRunner methodsFor: 'accessing-classes' stamp: 'tfel 5/11/2015 17:45'!
selectSubclasses
	"Fixed to update all selections now that the
	selection invalidation has been optimised."
	
	| classesForPackages |
	classesForPackages := self findClassesForCategories: categoriesSelected.	
	classesSelected := (classesSelected gather: [ :class |
		class withAllSubclasses select: [ :each |
			classesForPackages includes: each ] ])
		asSet.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!BenchmarkRunner methodsFor: 'history saving' stamp: 'tfel 5/11/2015 17:45'!
showDiffWith: aTestResult
	| string diff |

	diff := result diff: aTestResult.
	string := String streamContents: [:str|
		str nextPutAll: '----------------'; cr.
		str nextPutAll: 'Diff between current result with: ', aTestResult asString; cr.
		str nextPutAll: 'New passed: '.
		diff first do: [:s| str nextPutAll: s printString, ' '].
		str cr.
		str nextPutAll: 'New failures: '.
		diff second do: [:s| str nextPutAll: s printString, ' '].
		str cr.
		
		str nextPutAll: 'New errors: '.
		diff third do: [:s| str nextPutAll: s printString, ' '].
		str cr].
	
	Workspace new contents: string; openLabel: 'SUnit Progress'
	! !

!BenchmarkRunner methodsFor: 'utilities' stamp: 'tfel 5/11/2015 17:45'!
sortClass: aFirstClass before: aSecondClass
	| first second |
	first := aFirstClass withAllSuperclasses reversed.
	second := aSecondClass withAllSuperclasses reversed.
	1 to: (first size min: second size) do: [ :index | 
		(first at: index) == (second at: index)
			ifFalse: [ ^ (first at: index) name <= (second at: index) name ] ].
	^ second includes: aFirstClass.! !

!BenchmarkRunner methodsFor: 'accessing-testing' stamp: 'tfel 5/11/2015 18:34'!
statusColor
	self hasErrors 
		ifTrue: [ ^ Color red ].
	self hasFailures 
		ifTrue:[ ^ Color yellow ].
	^ Color green! !

!BenchmarkRunner methodsFor: 'building' stamp: 'tfel 5/11/2015 17:45'!
statusFrame
	^LayoutFrame new
		leftFraction: 0.5 offset: 0;
		topFraction: 0 offset: 0;
		rightFraction: 1 offset: 0;
		bottomFraction: 0 offset: self statusHeight! !

!BenchmarkRunner methodsFor: 'building' stamp: 'tfel 5/11/2015 17:45'!
statusHeight
	^Preferences standardCodeFont height * 2 + 12! !

!BenchmarkRunner methodsFor: 'accessing-menu' stamp: 'tfel 5/11/2015 20:08'!
statusMenu: aMenu

	^ aMenu! !

!BenchmarkRunner methodsFor: 'accessing-testing' stamp: 'tfel 5/15/2015 09:45'!
statusText
	^ resultList size asString, ' run, ', failedList size asString, ' slowed down, ', errorList size asString, ' errored'! !

!BenchmarkRunner methodsFor: 'updating' stamp: 'tfel 5/11/2015 17:45'!
update
	self updateCategories; updateClasses! !

!BenchmarkRunner methodsFor: 'updating' stamp: 'tfel 5/11/2015 17:45'!
updateCategories
	categories := self findCategories.
	categoriesSelected := categoriesSelected isNil
		ifTrue: [ Set new ]
		ifFalse: [
			categoriesSelected
				select: [ :each | categories includes: each ] ].
	self changed: #categoryList; changed: #categorySelected.! !

!BenchmarkRunner methodsFor: 'updating' stamp: 'tfel 5/11/2015 17:45'!
updateClasses
	| classesForCategories |
	classesForCategories := self findClassesForCategories: categoriesSelected.
	classes := classesForCategories asArray
		sort: [ :a :b | self sortClass: a before: b ].
	classIndex := 0.
	classesSelected := classesSelected isNil
		ifTrue: [ classesForCategories ]
		ifFalse: [ 
			classesSelected
				select: [ :each | classesForCategories includes: each ] ].
	self changed: #classList; changed: #classSelected; changed: #hasRunnable.! !

!BenchmarkRunner methodsFor: 'updating' stamp: 'tfel 5/11/2015 18:57'!
updateResults

	self updateStatus: false.
	resultSelected := nil.
	self 
		changed: #resultList; 
		changed: #resultSelected.
	failedSelected := nil.
	self 
		changed: #failedList; 
		changed: #failedSelected;
		changed: #hasFailures.
	errorSelected := nil.
	self 
		changed: #errorList; 
		changed: #errorSelected;
		changed: #hasErrors.! !

!BenchmarkRunner methodsFor: 'updating' stamp: 'tfel 5/11/2015 17:45'!
updateStatus: aBoolean
	"Update the status display, at most once a second if aBoolean is true."

	(aBoolean and: [ lastUpdate = Time totalSeconds ])
		ifTrue: [ ^ self ].
	self changed: #statusText; changed: #statusColor.
	lastUpdate := Time totalSeconds.! !

!BenchmarkRunner methodsFor: 'private' stamp: 'tfel 5/11/2015 17:45'!
windowIsClosing
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self! !

Object subclass: #BenchmarkSuite
	instanceVariableNames: 'numIterations suite selector runner results currentBenchmark timers problemSize numProcesses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark'!

!BenchmarkSuite commentStamp: 'tfel 5/15/2015 10:25' prior: 0!
A benchmark harness steers the execution and reporting of benchmarks.
For that purpose, it will use a designated benchmark runner to do the execution and a benchmark reporter to output the results.
The benchmark harness is also parameterized by the benchmark suites that are to be executed.

The simplest way to execute a benchmark suite is to use SMarkSuite >> #run.

However, directly using the harness classes gives more freedom on reporting and execution strategies.

A typical call of the harness from the commandline would result in the following invokation:
	SMarkHarness run: {'SMarkHarness'. 'SMarkLoops.benchIntLoop'. 1. 1. 5}!

BenchmarkSuite subclass: #BenchmarkAutosizeSuite
	instanceVariableNames: 'targetTime innerLoopIterations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark'!

!BenchmarkAutosizeSuite class methodsFor: 'defaults' stamp: 'tfel 5/11/2015 19:32'!
defaultTargetTime
	"600 milliseconds seems to be a reasonable target time for most problems.
	 It is a compromise between the general measurment noise as well as timer accuracy
	 and the absolute runtime of benchmarks"
	^ 600! !

!BenchmarkAutosizeSuite methodsFor: 'initialization' stamp: 'StefanMarr 3/19/2011 19:59'!
initialize
	super initialize.
	targetTime := self class defaultTargetTime.! !

!BenchmarkAutosizeSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 3/20/2011 10:27'!
performBenchmark: aSelector
	"First determine a useful number of inner loop iterations until the targetTime is reached."
	| execTime i |
	"make sure no timers are recorded for this"
	timers := nil.
	
	i := 1.
	execTime := Time millisecondsToRun: [ suite perform: aSelector. ].
	
	[ execTime > targetTime ] whileFalse: [
		i := i * 2. "Was thinking of doing something fancy here, but just go with this simple staight-forward solution"
		execTime := Time millisecondsToRun: [ 1 to: i do: [:ignored| suite perform: aSelector]].
	].

	innerLoopIterations := i.
	
	"Then start executing the benchmark"
	^ super performBenchmark: aSelector.! !

!BenchmarkAutosizeSuite methodsFor: 'as yet unclassified' stamp: 'tfel 4/21/2016 14:20'!
recordResults: timer for: aSelector
	| result name |
	name := suite benchmarkNameForSelector: aSelector.
	
	result := BenchmarkResult new
		total: timer totalTime / innerLoopIterations;
		incGCtotal: timer totalIncGCTime / innerLoopIterations;
		fullGCtotal: timer totalFullGCTime / innerLoopIterations;
		benchmarkName: name;
		suite: suite;
		criteria: timers;
		yourself.
	
	(results at: name ifAbsentPut: OrderedCollection new) add: result.! !

!BenchmarkAutosizeSuite methodsFor: 'benchmarking' stamp: 'DamienPollet 1/15/2015 11:46'!
runBaseBenchmark
	"baseBenchmark is not supported with autosizing. I do not see how that can be made possible since all different benchmarks will have different number of iterations, and the only way how a consistent baseline could be found would be to normalize the results, but well, incorporating the baseline measurement with the statistical evaluation is harder than just substracting a one time value..., I am not going to do that here for the moment. Stefan 2011-03-20"
	
	(suite respondsTo: #baseBenchmark) 
		ifFalse: [ ^ nil ].
	
	"I decided to go here with a silent solution to avoid thinking about logging frameworks and Transcript to console convertion..."
	self recordResults: (self class defaultTimer new: 'total') for: #baseBenchmark  ! !

!BenchmarkAutosizeSuite methodsFor: 'accessing' stamp: 'StefanMarr 3/19/2011 19:18'!
targetTime
	"Target time in milliseconds"
	^ targetTime! !

!BenchmarkAutosizeSuite methodsFor: 'accessing' stamp: 'StefanMarr 3/19/2011 19:18'!
targetTime: anIntInMilliseconds
	"Target time in milliseconds"
	targetTime := anIntInMilliseconds! !

!BenchmarkAutosizeSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 3/20/2011 10:31'!
timedBenchmarkExecution: aSelector
	"Will do a timed execution of the benchmark and return the result timer"
	| timer |
	timers := Dictionary new.

	timer := self createTimer: 'total'.
	
	timer start.
	1 to: innerLoopIterations do: [:ignored|
		suite perform: aSelector.
	].
	timer stop.
	
	self recordResults: timer for: aSelector.
	
	^ timer! !

BenchmarkAutosizeSuite subclass: #BenchmarkTestAutosizeSuite
	instanceVariableNames: 'performedBenchmarks notifyRunnerWasExecuted setUpCount tearDownCount didTearDownBenchC didSetUpBenchB baseBenchmarkExecuted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark-Tests'!

!BenchmarkTestAutosizeSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/19/2011 11:01'!
baseBenchmarkExecuted
	^ baseBenchmarkExecuted! !

!BenchmarkTestAutosizeSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/19/2011 11:01'!
countSetUpInvoke
	setUpCount := setUpCount + 1! !

!BenchmarkTestAutosizeSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/19/2011 11:01'!
countTearDownInvoke
	tearDownCount := tearDownCount + 1! !

!BenchmarkTestAutosizeSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/19/2011 11:01'!
countWasExecuted
	^ notifyRunnerWasExecuted ! !

!BenchmarkTestAutosizeSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/19/2011 11:01'!
didPerform: aSymbol
	performedBenchmarks add: aSymbol.! !

!BenchmarkTestAutosizeSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/19/2011 11:01'!
didRunBaseBenchmark
	baseBenchmarkExecuted := true.! !

!BenchmarkTestAutosizeSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/19/2011 11:01'!
didSetUpBenchB
	didSetUpBenchB := true.! !

!BenchmarkTestAutosizeSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/19/2011 11:01'!
didTearDownBenchC
	didTearDownBenchC := true.! !

!BenchmarkTestAutosizeSuite methodsFor: 'initialization' stamp: 'StefanMarr 3/19/2011 23:24'!
initialize
	super initialize.

	setUpCount := 0.
	tearDownCount := 0.
	notifyRunnerWasExecuted := 0.
	
	baseBenchmarkExecuted := false.

	performedBenchmarks := Set new.
	
	"set the targetTime to something which is more reasonable for testing"
	targetTime := 50.! !

!BenchmarkTestAutosizeSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/19/2011 11:01'!
isNotifyRunnerWasExecutedSet
	^ notifyRunnerWasExecuted! !

!BenchmarkTestAutosizeSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/19/2011 11:01'!
notifyRunnerWasExecuted
	notifyRunnerWasExecuted := notifyRunnerWasExecuted + 1! !

!BenchmarkTestAutosizeSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/19/2011 11:01'!
performedBenchmarks
	^ performedBenchmarks! !

!BenchmarkTestAutosizeSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/19/2011 11:01'!
setUp
	notifyRunnerWasExecuted := false! !

BenchmarkSuite subclass: #BenchmarkCogSuite
	instanceVariableNames: 'warmingUp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark'!

!BenchmarkCogSuite commentStamp: 'StefanMarr 12/30/2011 23:24' prior: 0!
This runner is doing warmup on for Cog VMs with just-in-time compilation.
The goal is to bring the JIT compiler into a steady state where no jitting is performed anymore during benchmarking.!

!BenchmarkCogSuite methodsFor: 'initialization' stamp: 'StefanMarr 12/30/2011 22:51'!
initialize
	super initialize.
	warmingUp := false.! !

!BenchmarkCogSuite methodsFor: 'initialization' stamp: 'StefanMarr 12/30/2011 23:26'!
performBenchmark: aSelector
	"Based on an email by Eliot from May 16th, 2011.
	 The first time a method is executed it will get into the inline cache.
	 The second time, it is found in the inline cache, which triggers the JIT compiler to produce code.
	 Thus, the third time it should be executed in the steady state."
	warmingUp := true.
		suite runBenchmark: aSelector.
		Smalltalk garbageCollect.
		suite runBenchmark: aSelector.
		Smalltalk garbageCollect.
	warmingUp := false.
	
	^ super performBenchmark: aSelector.! !

!BenchmarkCogSuite methodsFor: 'initialization' stamp: 'StefanMarr 12/30/2011 22:57'!
recordResults: timer for: aSelector
	"Only record the results when we are not in warmup mode."
	warmingUp ifFalse: [
		super recordResults: timer for: aSelector.
	].! !

BenchmarkSuite subclass: #BenchmarkProfileSuite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark'!

!BenchmarkProfileSuite commentStamp: '<historical>' prior: 0!
This runner profiles the benchmarks for better analysis. Unlike the classical benchmark runner this one will not collect the results. Instead it will execute the benchmarks in the system profiler.!

!BenchmarkProfileSuite class methodsFor: 'profiling' stamp: 'CamilloBruni 1/28/2013 18:19'!
execute: aSuite selector: aBenchmarkSelector
	| runner |
	runner := self new.
	aSuite runner: runner.
	runner 
		suite: aSuite;
		execute: aBenchmarkSelector.
	^ runner! !

!BenchmarkProfileSuite class methodsFor: 'profiling' stamp: 'CamilloBruni 1/28/2013 18:31'!
execute: aSuite selector: aBenchmarkSelector iterations: nIterations
	| runner |
	runner := self new.
	aSuite runner: runner.
	runner 
		suite: aSuite;
		iterations: nIterations;
		execute: aBenchmarkSelector.
	^ runner! !

!BenchmarkProfileSuite methodsFor: 'profiling' stamp: 'CamilloBruni 1/28/2013 18:24'!
execute
	"run all benchmnarks in a benchmark suite "
	[ suite run ] timeProfile! !

!BenchmarkProfileSuite methodsFor: 'profiling' stamp: 'CamilloBruni 1/28/2013 18:28'!
execute: aSelector
	
	[ self performBenchmark: aSelector ] timeProfile! !

!BenchmarkProfileSuite methodsFor: 'initialization' stamp: 'CamilloBruni 1/28/2013 18:28'!
initialize
	super initialize.
	numIterations := 1.! !

!BenchmarkProfileSuite methodsFor: 'benchmarks' stamp: 'CamilloBruni 1/28/2013 18:34'!
performBenchmark: aSelector
	currentBenchmark := aSelector.
	
	1 to: numIterations do: [:i|
		suite runBenchmark: aSelector ].	
	
	currentBenchmark := nil.! !

!BenchmarkProfileSuite methodsFor: 'benchmarks' stamp: 'CamilloBruni 1/28/2013 18:34'!
timedBenchmarkExecution: aSelector
	suite perform: aSelector! !

!BenchmarkSuite class methodsFor: 'defaults' stamp: 'tfel 5/15/2015 10:18'!
defaultArgumentParser
	^ BenchmarkArgumentParser! !

!BenchmarkSuite class methodsFor: 'defaults' stamp: 'StefanMarr 3/21/2011 11:43'!
defaultNumberOfIterations
	^ 1! !

!BenchmarkSuite class methodsFor: 'defaults' stamp: 'StefanMarr 5/14/2011 11:09'!
defaultNumberOfProcesses
	^ 1! !

!BenchmarkSuite class methodsFor: 'defaults' stamp: 'tfel 5/15/2015 10:18'!
defaultOutputDestination
	^ Smalltalk at:       #SMarkConsole
	            ifAbsent: [BenchmarkReporter defaultOutputDestination]! !

!BenchmarkSuite class methodsFor: 'defaults' stamp: 'tfel 5/15/2015 10:18'!
defaultReporter
	^ BenchmarkReporter defaultReporter! !

!BenchmarkSuite class methodsFor: 'defaults' stamp: 'tfel 5/15/2015 10:28'!
defaultTimer
	^ BenchmarkTimer! !

!BenchmarkSuite class methodsFor: 'benchmarking' stamp: 'StefanMarr 3/20/2011 19:51'!
execute: aSuite
	^ self execute: aSuite with: 1.! !

!BenchmarkSuite class methodsFor: 'benchmarking' stamp: 'sm 5/25/2011 17:41'!
execute: runner andReport: reporter
	runner reportConfiguration: self defaultOutputDestination.
	runner execute.
	reporter runner: runner.
	reporter outputStream: self defaultOutputDestination.
	reporter report.! !

!BenchmarkSuite class methodsFor: 'benchmarking' stamp: 'StefanMarr 3/20/2011 19:51'!
execute: aSuite with: nIterations
	| runner |
	runner := self new.
	aSuite runner: runner.
	runner suite: aSuite.
	runner iterations: nIterations.  
	runner execute.
	^ runner! !

!BenchmarkSuite class methodsFor: 'helper' stamp: 'StefanMarr 12/30/2011 20:00'!
parseArguments: arguments
	| parser |
	parser := self defaultArgumentParser new.
	parser harness: self.
	^ parser parse: arguments.! !

!BenchmarkSuite class methodsFor: 'script entry' stamp: 'tfel 5/15/2015 10:42'!
run: arguments
	"Executed from the command line using something similar to
	 ./vm my.image BenchmarkSuite BenchmarkReporter SMarkLoops\>\>benchIntLoop 1 1 5
	 ./vm my.image BenchmarkSuite BenchmarkReporter SMarkLoops.benchIntLoop 1 1 5"

	| runner reporter runnerAndReporter |
	
	(self shouldShowUsage: arguments)
		ifTrue: [
			self usage.
			^ self.
		].
	
	runnerAndReporter := self parseArguments: arguments.
	runner := runnerAndReporter first.
	reporter := runnerAndReporter second.  
	
	runner executeAndReport: reporter.! !

!BenchmarkSuite class methodsFor: 'script entry' stamp: 'tfel 5/15/2015 10:42'!
run: aSuiteClass specificBenchmark: aBenchmark iterations: i processes: p problemSize: s reporter: reporterClass

	| reporter runner suite |
	suite := aSuiteClass new.
	runner := self new
		selector: aBenchmark;
		suite: suite;
		iterations: i;
		processes: p;
		problemSize: s;
		yourself.
	reporter := (reporterClass ifNil: [self defaultReporter]) new.
	runner executeAndReport: reporter.
	^ reporter
! !

!BenchmarkSuite class methodsFor: 'helper' stamp: ''!
shouldShowUsage: arguments
	
	arguments size < 2 ifTrue: [^ true ].
	
	^ arguments anySatisfy: [:elem | (elem = '--help') or: [elem = '-?'] ].  ! !

!BenchmarkSuite class methodsFor: 'helper' stamp: 'StephaneDucasse 6/16/2013 21:04'!
usage
	| usage |
	"Example usage: SMarkHarness SMarkRunner SMarkReporter SMarkLoops.benchIntLoop 1 1 5"
	
	usage := self usageHeader.
	
	usage := usage, 'Arguments:', String crlf.
	usage := self usageRunner:   usage.
	usage := self usageReporter: usage.
	usage := usage, ' suiteOrBenchmark   required, either a SMarkSuite with benchmarks,', String crlf.
	usage := usage, '                              or a benchmark denoted by Suite.benchName', String crlf.
	usage := self usageBenchmarkParameters: usage.
	
	self defaultOutputDestination print: usage.! !

!BenchmarkSuite class methodsFor: 'helper' stamp: ''!
usageBenchmarkParameters: usage
	^ usage,	' iterations         optional, number of times the benchmarks are repeated', String crlf,
				' processes          optional, number of processes/threads used by the benchmarks', String crlf,
				' problemSize        optional, depending on benchmark for instance number of', String crlf,
				'                              inner iterations or size of used data set', String crlf.
! !

!BenchmarkSuite class methodsFor: 'helper' stamp: ''!
usageHeader
	| usage |
	usage := 'SMark Benchmark Framework, version: ', self version, String crlf.
	usage := usage, String crlf.
	usage := usage, 'Usage: <vm+image> ', self name, ' [runner] [reporter] <suiteOrBenchmark>', String crlf.
	usage := usage, '                               [iterations [processes [problemSize]]]', String crlf.
	usage := usage, String crlf.
	^ usage! !

!BenchmarkSuite class methodsFor: 'helper' stamp: ''!
usageReporter: usage
	^ usage,	' reporter           optional, a SMarkReporter class that processes', String crlf,
				'                              and displays the results', String crlf.
	! !

!BenchmarkSuite class methodsFor: 'helper' stamp: 'tfel 5/15/2015 10:40'!
usageRunner: usage
	^ usage! !

!BenchmarkSuite class methodsFor: 'helper' stamp: ''!
version
	(Smalltalk classNamed: #ConfigurationOfBenchmarking)
		ifNotNilDo: [:cfg |
			^ cfg project currentVersion versionNumber asString.
		].
	  
	(Smalltalk classNamed: #MCPackage)
		ifNotNilDo: [:mcp |
			| package |
			package := mcp named: 'SMark'.
			package hasWorkingCopy ifTrue: [
				^ package workingCopy ancestors first name.
			].
		].
	
	^ ''.! !

!BenchmarkSuite methodsFor: 'helper' stamp: 'StefanMarr 3/20/2011 10:28'!
createTimer: name
	"Create and register a new timer for the current benchmark"
	| timer |
	timer := self class defaultTimer new: name.
	
	timers ifNotNil: [
		timers at: name put: timer.
	].
	
	^ timer.! !

!BenchmarkSuite methodsFor: 'execution' stamp: 'tfel 5/11/2015 19:58'!
execute
	selector ifNotNil: [suite runOnly: selector].
	suite run.
	self runBaseBenchmark.
	^ results
	! !

!BenchmarkSuite methodsFor: 'execution' stamp: 'tfel 5/15/2015 11:41'!
executeAndReport: reporter
	self reportConfiguration: self class defaultOutputDestination.
	self execute.
	reporter runner: self.
	reporter outputStream: self class defaultOutputDestination.
	reporter report.
! !

!BenchmarkSuite methodsFor: 'initialization' stamp: 'StefanMarr 5/14/2011 11:10'!
initialize
	super initialize.
	numIterations := self class defaultNumberOfIterations.
	numProcesses  := self class defaultNumberOfProcesses.
	results := Dictionary new.! !

!BenchmarkSuite methodsFor: 'accessing' stamp: 'StefanMarr 3/21/2011 12:20'!
iterations
	^ numIterations! !

!BenchmarkSuite methodsFor: 'accessing' stamp: 'StefanMarr 3/21/2011 12:20'!
iterations: anInteger
	numIterations := anInteger! !

!BenchmarkSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 4/15/2011 11:50'!
performBenchmark: aSelector
	currentBenchmark := aSelector.
	
	1 to: numIterations do: [:i|
		"self timedBenchmarkExecution: aSelector."
		suite runBenchmark: aSelector.  
	].	
	
	currentBenchmark := nil.
	
	^ results at: (suite benchmarkNameForSelector: aSelector)! !

!BenchmarkSuite methodsFor: 'printing' stamp: 'CamilloBruni 9/5/2011 13:13'!
printOn: aStream
	^ self reportOn: aStream.! !

!BenchmarkSuite methodsFor: 'accessing' stamp: 'StefanMarr 5/8/2013 13:55'!
problemSize
	<omniUnenforced> "Hint for the OMOP that it is part of the meta infrastructure"
	^ problemSize! !

!BenchmarkSuite methodsFor: 'accessing' stamp: 'StefanMarr 8/21/2012 09:44'!
problemSize: aValue
	"Do some conversion to make it easier for the benchmarks"
	(aValue isString and: [aValue isAllDigits]) ifTrue: [
		problemSize := Number readFrom: aValue.
		^ self.
	].

	problemSize := aValue! !

!BenchmarkSuite methodsFor: 'accessing' stamp: 'StefanMarr 5/14/2011 11:08'!
processes
	"The standard runner does use only a single process, but in case a benchmark supports parallelism it can query for the intended degree of parallelism"
	^ numProcesses! !

!BenchmarkSuite methodsFor: 'accessing' stamp: 'StefanMarr 5/14/2011 11:08'!
processes: anInt
	"The standard runner does use only a single process, but a benchmark can use that to do its own parallelism"
	numProcesses := anInt! !

!BenchmarkSuite methodsFor: 'helper' stamp: 'tfel 4/21/2016 14:22'!
recordResults: timer for: aSelector
	| result name |
	name := suite benchmarkNameForSelector: aSelector.
	
	result := BenchmarkResult new
		total: timer totalTime;
		incGCtotal: timer totalIncGCTime;
		fullGCtotal: timer totalFullGCTime;
		benchmarkName: name;
		suite: suite;
		criteria: timers;
		yourself.
	
	(results at: name ifAbsentPut: OrderedCollection new) add: result.! !

!BenchmarkSuite methodsFor: 'accessing' stamp: 'tfel 5/15/2015 10:18'!
report
	BenchmarkReporter defaultReporter reportFor: self.  
	! !

!BenchmarkSuite methodsFor: 'reporting' stamp: 'sm 5/25/2011 17:50'!
reportConfiguration: aStream
	aStream << 'Runner Configuration:';cr.
	aStream << ('  iterations: ', numIterations asString); cr.
	aStream << ('  processes: ', numProcesses asString); cr.
	aStream << ('  problem size: ', problemSize asString); cr.
! !

!BenchmarkSuite methodsFor: 'reporting' stamp: 'tfel 5/15/2015 10:18'!
reportOn: aStream
	BenchmarkReporter defaultReporter reportFor: self on: aStream  
	! !

!BenchmarkSuite methodsFor: 'accessing' stamp: 'StefanMarr 3/18/2011 19:41'!
results
	^ results! !

!BenchmarkSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 3/18/2011 18:42'!
runBaseBenchmark
	"In certain sitatuations it is one wants a baseline that is incooprated in all 
	 benchmark results to be substracted from the final values.
	
	#baseBenchmark can be used to charaterize such a baseline"
	
	(suite respondsTo: #baseBenchmark) 
		ifFalse: [ ^ nil ].
	
	^ self performBenchmark: #baseBenchmark.! !

!BenchmarkSuite methodsFor: 'accessing' stamp: 'tfel 5/11/2015 19:57'!
selector

	^ selector! !

!BenchmarkSuite methodsFor: 'accessing' stamp: 'tfel 5/11/2015 19:57'!
selector: aSymbol

	selector := aSymbol.! !

!BenchmarkSuite methodsFor: 'accessing' stamp: 'StefanMarr 3/20/2011 18:45'!
suite
	^ suite! !

!BenchmarkSuite methodsFor: 'accessing' stamp: 'StefanMarr 4/15/2011 16:14'!
suite: aBenchmarkSuite
	suite := aBenchmarkSuite.
	suite runner: self.! !

!BenchmarkSuite methodsFor: 'benchmarking' stamp: 'ReinoutStevens 12/6/2011 14:30'!
timedBenchmarkExecution: aSelector
	"Will do a timed execution of the benchmark and return the result timer"
	| timer result |
	timers := Dictionary new.

	timer := self createTimer: 'total'.
	
	timer start.
	result := suite perform: aSelector.
	timer stop.
	suite processResult: result withTimer: timer.
	
	self recordResults: timer for: aSelector.
	
	^ timer! !

BenchmarkSuite subclass: #BenchmarkTestSuite
	instanceVariableNames: 'performedBenchmarks notifyRunnerWasExecuted setUpCount tearDownCount didTearDownBenchC didSetUpBenchB baseBenchmarkExecuted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark-Tests'!

!BenchmarkTestSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/18/2011 18:35'!
baseBenchmarkExecuted
	^ baseBenchmarkExecuted! !

!BenchmarkTestSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/18/2011 17:36'!
countSetUpInvoke
	setUpCount := setUpCount + 1! !

!BenchmarkTestSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/18/2011 17:39'!
countTearDownInvoke
	tearDownCount := tearDownCount + 1! !

!BenchmarkTestSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/18/2011 19:44'!
countWasExecuted
	^ notifyRunnerWasExecuted ! !

!BenchmarkTestSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/18/2011 19:00'!
didPerform: aSymbol
	performedBenchmarks add: aSymbol.! !

!BenchmarkTestSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/18/2011 17:56'!
didRunBaseBenchmark
	baseBenchmarkExecuted := true.! !

!BenchmarkTestSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/18/2011 17:43'!
didSetUpBenchB
	didSetUpBenchB := true.! !

!BenchmarkTestSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/18/2011 17:42'!
didTearDownBenchC
	didTearDownBenchC := true.! !

!BenchmarkTestSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/15/2011 12:14'!
hasSetUpBenchB
	^ didSetUpBenchB.! !

!BenchmarkTestSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/15/2011 12:21'!
hasTearDownBenchC
	^ didTearDownBenchC! !

!BenchmarkTestSuite methodsFor: 'initialization' stamp: 'StefanMarr 3/18/2011 19:49'!
initialize
	super initialize.

	setUpCount := 0.
	tearDownCount := 0.
	notifyRunnerWasExecuted := 0.
	
	baseBenchmarkExecuted := false.

	performedBenchmarks := OrderedCollection new.! !

!BenchmarkTestSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/15/2011 22:16'!
isNotifyRunnerWasExecutedSet
	^ notifyRunnerWasExecuted! !

!BenchmarkTestSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/18/2011 19:44'!
notifyRunnerWasExecuted
	notifyRunnerWasExecuted := notifyRunnerWasExecuted + 1! !

!BenchmarkTestSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/18/2011 19:00'!
performedBenchmarks
	^ performedBenchmarks! !

!BenchmarkTestSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/15/2011 22:15'!
setUp
	notifyRunnerWasExecuted := false! !

!BenchmarkTestSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/15/2011 12:27'!
setUpCount
	^ setUpCount! !

!BenchmarkTestSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/15/2011 12:39'!
tearDownCount
	^ tearDownCount! !

BenchmarkSuite subclass: #BenchmarkWeakScalingSuite
	instanceVariableNames: 'numInnerIterations runningProcesses completionSignal runningProcessesMtx'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark'!

!BenchmarkWeakScalingSuite commentStamp: 'tfel 5/15/2015 10:33' prior: 0!
This runner is specific to platforms with support for real parallelism.

Weak scaling is defined as how the solution time varies with the number of processors for a fixed problem size per processor.

This class is optimized for use from the command-line. It is especially meant to be used together with ReBench, a tool to execute and document benchmarks reproducibly.

See: https://github.com/smarr/ReBench#readme!

BenchmarkWeakScalingSuite subclass: #BenchmarkTestWeakScalingSuite
	instanceVariableNames: 'setUpCount tearDownCount notifyRunnerWasExecuted performedBenchmarks baseBenchmarkExecuted didSetUpBenchB didTearDownBenchC'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark-Tests'!

!BenchmarkTestWeakScalingSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/15/2011 10:44'!
baseBenchmarkExecuted
	^ baseBenchmarkExecuted! !

!BenchmarkTestWeakScalingSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/15/2011 10:41'!
countSetUpInvoke
	setUpCount := setUpCount + 1! !

!BenchmarkTestWeakScalingSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/15/2011 10:41'!
countTearDownInvoke
	tearDownCount := tearDownCount + 1! !

!BenchmarkTestWeakScalingSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/15/2011 10:41'!
countWasExecuted
	^ notifyRunnerWasExecuted ! !

!BenchmarkTestWeakScalingSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/15/2011 10:41'!
didPerform: aSymbol
	performedBenchmarks add: aSymbol.! !

!BenchmarkTestWeakScalingSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/15/2011 10:42'!
didRunBaseBenchmark
	baseBenchmarkExecuted := true.! !

!BenchmarkTestWeakScalingSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/15/2011 10:42'!
didSetUpBenchB
	didSetUpBenchB := true.! !

!BenchmarkTestWeakScalingSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/15/2011 10:42'!
didTearDownBenchC
	didTearDownBenchC := true.! !

!BenchmarkTestWeakScalingSuite methodsFor: 'initialization' stamp: 'StefanMarr 4/15/2011 10:42'!
initialize
	super initialize.

	setUpCount := 0.
	tearDownCount := 0.
	notifyRunnerWasExecuted := 0.
	
	baseBenchmarkExecuted := false.

	performedBenchmarks := OrderedCollection new.! !

!BenchmarkTestWeakScalingSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/15/2011 13:20'!
isNotifyRunnerWasExecutedSet
	^ notifyRunnerWasExecuted > 0! !

!BenchmarkTestWeakScalingSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/15/2011 10:42'!
notifyRunnerWasExecuted
	notifyRunnerWasExecuted := notifyRunnerWasExecuted + 1! !

!BenchmarkTestWeakScalingSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/15/2011 10:42'!
performedBenchmarks
	^ performedBenchmarks! !

!BenchmarkTestWeakScalingSuite methodsFor: 'as yet unclassified' stamp: 'StefanMarr 4/15/2011 10:43'!
setUp
	notifyRunnerWasExecuted := false! !

!BenchmarkWeakScalingSuite class methodsFor: 'helper' stamp: 'tfel 5/15/2015 10:35'!
defaultArgumentParser
	^ BenchmarkWeakScalingArgumentParser! !

!BenchmarkWeakScalingSuite class methodsFor: 'defaults' stamp: 'StefanMarr 4/15/2011 15:42'!
defaultNumberOfInnerIterations
	"The number of iterations of the inner loop
	 in which the benchmark is executed."
	^ 1! !

!BenchmarkWeakScalingSuite class methodsFor: 'defaults' stamp: 'tfel 5/15/2015 10:33'!
defaultReporter
	^ BenchmarkWeakScalingReporter! !

!BenchmarkWeakScalingSuite class methodsFor: 'helper' stamp: 'sm 5/25/2011 17:20'!
usageBenchmarkParameters: usage
	^ usage,		' processes          optional, number of processes/threads used by the benchmarks', String crlf,
				' inner-iterations   optional, number of iterations done by a single process', String crlf,
				' problemSize        optional, depending on benchmark for instance size of used data set', String crlf.
				! !

!BenchmarkWeakScalingSuite class methodsFor: 'helper' stamp: 'sm 5/25/2011 17:20'!
usageHeader
	| usage |
	usage := 'SMark Benchmark Framework, version: ', self version, String crlf.
	usage := usage, String crlf.
	usage := usage, 'Usage: <vm+image> ', self name,
				' <suiteOrBenchmark> [processes [inner-iterations [problemSize]]]', String crlf.
	usage := usage, String crlf.
	
	usage := usage, '  This harness is used for weak-scalling benchmarks.', String crlf.
	usage := usage, '  Use the SMarkHarness for more general settings, it offers more options.', String crlf.
	
	usage := usage, String crlf.
	^ usage! !

!BenchmarkWeakScalingSuite class methodsFor: 'helper' stamp: ''!
usageReporter: usage
	"Will rely on default, which is good for ReBench, so do not advertise option."
	^ usage! !

!BenchmarkWeakScalingSuite class methodsFor: 'helper' stamp: ''!
usageRunner: usage
	"Will rely on default, which is good for ReBench, so do not advertise option."
	^ usage! !

!BenchmarkWeakScalingSuite methodsFor: 'benchmarking' stamp: 'tfel 5/15/2015 10:29'!
execute: aSelector withProcesses: numberOfProcesses withTimer: timer
	"This case is meant for all cases. REM: this is also used for numProc==1 to be able to measure the process start overhead in all cases.
	 It will start the processes and wait for their completion."
	
	| processes |
	processes			:= Array new: numberOfProcesses.
	runningProcessesMtx := Semaphore forMutualExclusion.
	completionSignal		:= Semaphore new.
	runningProcesses := numberOfProcesses.
	
	"First initialize the processes"
	1 to: numberOfProcesses do: [ :procNum |
		| proc |
		proc := BenchmarkWeakScalingRunnerExecutor createFor: aSelector for: numInnerIterations with: self and: suite.
		proc priority: Processor highestPriority.
		proc name: (self class name, '-',  procNum asString).
		processes at: procNum put: proc.
		"On: procNum"
	].
	
	"Now, execute the benchmark and do the timing now"
	timer start.
	1 to: numberOfProcesses do: [ :procNum |
		(processes at: procNum) resume.
	].
	completionSignal wait.
	timer stop.
	! !

!BenchmarkWeakScalingSuite methodsFor: 'benchmarking' stamp: 'sm 5/30/2011 16:17'!
executorCompleted
	runningProcessesMtx critical: [
		runningProcesses := runningProcesses - 1.
		(runningProcesses == 0) ifTrue: [
			completionSignal signal.
		]
	]! !

!BenchmarkWeakScalingSuite methodsFor: 'initialization' stamp: 'StefanMarr 4/15/2011 15:43'!
initialize
	super initialize.
	numProcesses			:= self class defaultNumberOfProcesses.
	numInnerIterations	:= self class defaultNumberOfInnerIterations.
! !

!BenchmarkWeakScalingSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 4/15/2011 15:43'!
innerIterations
	"The number of inner iterations the benchmark is executed inside a processes"
	^ numInnerIterations! !

!BenchmarkWeakScalingSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 4/15/2011 15:43'!
innerIterations: anInteger
	"The number of inner iterations the benchmark is executed inside a processes"
	numInnerIterations := anInteger! !

!BenchmarkWeakScalingSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 4/15/2011 10:54'!
processes
	^ numProcesses! !

!BenchmarkWeakScalingSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 4/15/2011 10:53'!
processes: anInteger
	numProcesses := anInteger! !

!BenchmarkWeakScalingSuite methodsFor: 'reporting' stamp: 'sm 5/25/2011 17:50'!
reportConfiguration: aStream
	super reportConfiguration: aStream.
	aStream << ('inner iterations: ', numInnerIterations asString); cr.! !

!BenchmarkWeakScalingSuite methodsFor: 'benchmarking' stamp: 'sm 5/25/2011 18:31'!
timedBenchmarkExecution: aSelector
	"Will do a timed execution of the benchmark and return the result timer"
	| timer |
	timers := Dictionary new.

	timer := self createTimer: 'total'.
	
	self execute: aSelector withProcesses: numProcesses withTimer: timer.
	
	self recordResults: timer for: aSelector.
	
	^ timer! !

Object subclass: #BenchmarkTimer
	instanceVariableNames: 'startTime elapsedTime name startIncGCs startIncGCTime startFullGCs startFullGCTime incGCs incGCTime fullGCs fullGCTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark'!

!BenchmarkTimer commentStamp: '<historical>' prior: 0!
A SMarkTimer is a simple timer.
A subclass can measure alternative metrics, or for instance use different time sources.

A subclass of SMarkRunner can then use the custom timer class by overriding SMarkRunner class >> #defaultTimer.!

!BenchmarkTimer class methodsFor: 'instance creation' stamp: 'StefanMarr 3/14/2011 08:54'!
new: aName
	| timer |
	
	timer := super new.
	timer name: aName.
	
	^timer! !

!BenchmarkTimer methodsFor: 'timing' stamp: 'StephaneDucasse 6/16/2013 21:15'!
currentMillis

	^ Time millisecondClockValue! !

!BenchmarkTimer methodsFor: 'initialization' stamp: 'tfel 4/21/2016 12:59'!
initialize
	super initialize.
	elapsedTime := 0.
	incGCs := 0.
	fullGCs := 0.
	incGCTime := 0.
	fullGCTime := 0.! !

!BenchmarkTimer methodsFor: 'accessing' stamp: 'StefanMarr 3/14/2011 08:54'!
name
	^name! !

!BenchmarkTimer methodsFor: 'accessing' stamp: 'StefanMarr 3/14/2011 08:54'!
name: aString
	name := aString ! !

!BenchmarkTimer methodsFor: 'timing' stamp: 'StefanMarr 3/14/2011 08:54'!
reset
	startTime := 0.
	elapsedTime := 0.! !

!BenchmarkTimer methodsFor: 'timing' stamp: 'tfel 4/21/2016 13:02'!
start
	| params |
	params := Smalltalk getVMParameters.
	startTime := self currentMillis.
	startIncGCs := params at: 9.
	startIncGCTime := params at: 10.
	startFullGCs := params at: 7.
	startFullGCTime := params at: 8.
! !

!BenchmarkTimer methodsFor: 'timing' stamp: 'tfel 4/21/2016 13:54'!
stop
	| elapsedInThisPeriod current params fullGCTimeInThisPeriod fullGCsInThisPeriod incGCTimeInThisPeriod incGCsInThisPeriod |
	current := self currentMillis.
	params := Smalltalk getVMParameters.
	elapsedInThisPeriod := Time milliseconds: current since: startTime.
	incGCsInThisPeriod := (params at: 9) - startIncGCs.
	incGCTimeInThisPeriod := (params at: 10) - startIncGCTime.
	fullGCsInThisPeriod := (params at: 7) - startFullGCs.
	fullGCTimeInThisPeriod := (params at: 8) - startFullGCTime.

	incGCs := incGCs + incGCsInThisPeriod.
	incGCTime := incGCTime + incGCTimeInThisPeriod.
	fullGCs := fullGCs + fullGCsInThisPeriod.
	fullGCTime := fullGCTime + fullGCTimeInThisPeriod.
	elapsedTime := elapsedTime + elapsedInThisPeriod.
! !

!BenchmarkTimer methodsFor: 'timing' stamp: 'tfel 4/21/2016 12:58'!
totalFullGCTime

	^ fullGCTime! !

!BenchmarkTimer methodsFor: 'timing' stamp: 'tfel 4/21/2016 12:58'!
totalFullGCs

	^ fullGCs! !

!BenchmarkTimer methodsFor: 'timing' stamp: 'tfel 4/21/2016 12:58'!
totalIncGCTime

	^ incGCTime! !

!BenchmarkTimer methodsFor: 'timing' stamp: 'tfel 4/21/2016 12:58'!
totalIncGCs

	^ incGCs! !

!BenchmarkTimer methodsFor: 'accessing' stamp: 'StefanMarr 3/14/2011 08:54'!
totalTime
	^elapsedTime! !

Object subclass: #BenchmarkWeakScalingRunnerExecutor
	instanceVariableNames: 'numInnerIterations benchmarkSelector suite runner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmark'!

!BenchmarkWeakScalingRunnerExecutor class methodsFor: 'as yet unclassified' stamp: 'sm 5/30/2011 16:33'!
createFor: aSelector for: numIterations with: aRunner and: aSuite
	| o |
	o := self new.
	o runner: aRunner.
	o suite: aSuite.
	o innerIterations: numIterations.
	o benchmarkSelector: aSelector.
	^ ([ o run ] newProcess)! !

!BenchmarkWeakScalingRunnerExecutor methodsFor: 'accessing' stamp: 'sm 5/30/2011 16:20'!
benchmarkSelector: aSelector
	benchmarkSelector := aSelector! !

!BenchmarkWeakScalingRunnerExecutor methodsFor: 'accessing' stamp: 'sm 5/30/2011 16:20'!
innerIterations: anInt
	numInnerIterations := anInt! !

!BenchmarkWeakScalingRunnerExecutor methodsFor: 'benchmarking' stamp: 'sm 5/30/2011 16:22'!
run
	1 to: numInnerIterations do: [:i |
		suite perform: benchmarkSelector.].
	
	runner executorCompleted.! !

!BenchmarkWeakScalingRunnerExecutor methodsFor: 'accessing' stamp: 'sm 5/30/2011 16:21'!
runner: aRunner
	runner := aRunner! !

!BenchmarkWeakScalingRunnerExecutor methodsFor: 'accessing' stamp: 'sm 5/30/2011 16:21'!
suite: aSuite
	suite := aSuite! !
BenchmarkConsole initialize!
BenchmarkRunner initialize!
